// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acl

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteACLDefaultsAcceptedCode is the HTTP code returned for type DeleteACLDefaultsAccepted
const DeleteACLDefaultsAcceptedCode int = 202

/*
DeleteACLDefaultsAccepted Configuration change accepted and reload requested

swagger:response deleteAclDefaultsAccepted
*/
type DeleteACLDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteACLDefaultsAccepted creates DeleteACLDefaultsAccepted with default headers values
func NewDeleteACLDefaultsAccepted() *DeleteACLDefaultsAccepted {

	return &DeleteACLDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the delete Acl defaults accepted response
func (o *DeleteACLDefaultsAccepted) WithReloadID(reloadID string) *DeleteACLDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete Acl defaults accepted response
func (o *DeleteACLDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteACLDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteACLDefaultsNoContentCode is the HTTP code returned for type DeleteACLDefaultsNoContent
const DeleteACLDefaultsNoContentCode int = 204

/*
DeleteACLDefaultsNoContent ACL line deleted

swagger:response deleteAclDefaultsNoContent
*/
type DeleteACLDefaultsNoContent struct {
}

// NewDeleteACLDefaultsNoContent creates DeleteACLDefaultsNoContent with default headers values
func NewDeleteACLDefaultsNoContent() *DeleteACLDefaultsNoContent {

	return &DeleteACLDefaultsNoContent{}
}

// WriteResponse to the client
func (o *DeleteACLDefaultsNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteACLDefaultsNotFoundCode is the HTTP code returned for type DeleteACLDefaultsNotFound
const DeleteACLDefaultsNotFoundCode int = 404

/*
DeleteACLDefaultsNotFound The specified resource was not found

swagger:response deleteAclDefaultsNotFound
*/
type DeleteACLDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteACLDefaultsNotFound creates DeleteACLDefaultsNotFound with default headers values
func NewDeleteACLDefaultsNotFound() *DeleteACLDefaultsNotFound {

	return &DeleteACLDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete Acl defaults not found response
func (o *DeleteACLDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *DeleteACLDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Acl defaults not found response
func (o *DeleteACLDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Acl defaults not found response
func (o *DeleteACLDefaultsNotFound) WithPayload(payload *models.Error) *DeleteACLDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Acl defaults not found response
func (o *DeleteACLDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteACLDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteACLDefaultsDefault General Error

swagger:response deleteAclDefaultsDefault
*/
type DeleteACLDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteACLDefaultsDefault creates DeleteACLDefaultsDefault with default headers values
func NewDeleteACLDefaultsDefault(code int) *DeleteACLDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteACLDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete Acl defaults default response
func (o *DeleteACLDefaultsDefault) WithStatusCode(code int) *DeleteACLDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete Acl defaults default response
func (o *DeleteACLDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete Acl defaults default response
func (o *DeleteACLDefaultsDefault) WithConfigurationVersion(configurationVersion string) *DeleteACLDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Acl defaults default response
func (o *DeleteACLDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Acl defaults default response
func (o *DeleteACLDefaultsDefault) WithPayload(payload *models.Error) *DeleteACLDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Acl defaults default response
func (o *DeleteACLDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteACLDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
