// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acl

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetACLDefaultsOKCode is the HTTP code returned for type GetACLDefaultsOK
const GetACLDefaultsOKCode int = 200

/*
GetACLDefaultsOK Successful operation

swagger:response getAclDefaultsOK
*/
type GetACLDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.ACL `json:"body,omitempty"`
}

// NewGetACLDefaultsOK creates GetACLDefaultsOK with default headers values
func NewGetACLDefaultsOK() *GetACLDefaultsOK {

	return &GetACLDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Acl defaults o k response
func (o *GetACLDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetACLDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Acl defaults o k response
func (o *GetACLDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Acl defaults o k response
func (o *GetACLDefaultsOK) WithPayload(payload *models.ACL) *GetACLDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Acl defaults o k response
func (o *GetACLDefaultsOK) SetPayload(payload *models.ACL) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetACLDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetACLDefaultsNotFoundCode is the HTTP code returned for type GetACLDefaultsNotFound
const GetACLDefaultsNotFoundCode int = 404

/*
GetACLDefaultsNotFound The specified resource was not found

swagger:response getAclDefaultsNotFound
*/
type GetACLDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetACLDefaultsNotFound creates GetACLDefaultsNotFound with default headers values
func NewGetACLDefaultsNotFound() *GetACLDefaultsNotFound {

	return &GetACLDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Acl defaults not found response
func (o *GetACLDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *GetACLDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Acl defaults not found response
func (o *GetACLDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Acl defaults not found response
func (o *GetACLDefaultsNotFound) WithPayload(payload *models.Error) *GetACLDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Acl defaults not found response
func (o *GetACLDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetACLDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetACLDefaultsDefault General Error

swagger:response getAclDefaultsDefault
*/
type GetACLDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetACLDefaultsDefault creates GetACLDefaultsDefault with default headers values
func NewGetACLDefaultsDefault(code int) *GetACLDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetACLDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get Acl defaults default response
func (o *GetACLDefaultsDefault) WithStatusCode(code int) *GetACLDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get Acl defaults default response
func (o *GetACLDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get Acl defaults default response
func (o *GetACLDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetACLDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Acl defaults default response
func (o *GetACLDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Acl defaults default response
func (o *GetACLDefaultsDefault) WithPayload(payload *models.Error) *GetACLDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Acl defaults default response
func (o *GetACLDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetACLDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
