// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acl

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllACLDefaultsOKCode is the HTTP code returned for type GetAllACLDefaultsOK
const GetAllACLDefaultsOKCode int = 200

/*
GetAllACLDefaultsOK Successful operation

swagger:response getAllAclDefaultsOK
*/
type GetAllACLDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.Acls `json:"body,omitempty"`
}

// NewGetAllACLDefaultsOK creates GetAllACLDefaultsOK with default headers values
func NewGetAllACLDefaultsOK() *GetAllACLDefaultsOK {

	return &GetAllACLDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all Acl defaults o k response
func (o *GetAllACLDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetAllACLDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all Acl defaults o k response
func (o *GetAllACLDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all Acl defaults o k response
func (o *GetAllACLDefaultsOK) WithPayload(payload models.Acls) *GetAllACLDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all Acl defaults o k response
func (o *GetAllACLDefaultsOK) SetPayload(payload models.Acls) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllACLDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.Acls{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllACLDefaultsDefault General Error

swagger:response getAllAclDefaultsDefault
*/
type GetAllACLDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllACLDefaultsDefault creates GetAllACLDefaultsDefault with default headers values
func NewGetAllACLDefaultsDefault(code int) *GetAllACLDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllACLDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all Acl defaults default response
func (o *GetAllACLDefaultsDefault) WithStatusCode(code int) *GetAllACLDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all Acl defaults default response
func (o *GetAllACLDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all Acl defaults default response
func (o *GetAllACLDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetAllACLDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all Acl defaults default response
func (o *GetAllACLDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all Acl defaults default response
func (o *GetAllACLDefaultsDefault) WithPayload(payload *models.Error) *GetAllACLDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all Acl defaults default response
func (o *GetAllACLDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllACLDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
