// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acl

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// ReplaceAllACLDefaultsOKCode is the HTTP code returned for type ReplaceAllACLDefaultsOK
const ReplaceAllACLDefaultsOKCode int = 200

/*
ReplaceAllACLDefaultsOK All ACL lines replaced

swagger:response replaceAllAclDefaultsOK
*/
type ReplaceAllACLDefaultsOK struct {

	/*
	  In: Body
	*/
	Payload models.Acls `json:"body,omitempty"`
}

// NewReplaceAllACLDefaultsOK creates ReplaceAllACLDefaultsOK with default headers values
func NewReplaceAllACLDefaultsOK() *ReplaceAllACLDefaultsOK {

	return &ReplaceAllACLDefaultsOK{}
}

// WithPayload adds the payload to the replace all Acl defaults o k response
func (o *ReplaceAllACLDefaultsOK) WithPayload(payload models.Acls) *ReplaceAllACLDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Acl defaults o k response
func (o *ReplaceAllACLDefaultsOK) SetPayload(payload models.Acls) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllACLDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.Acls{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllACLDefaultsAcceptedCode is the HTTP code returned for type ReplaceAllACLDefaultsAccepted
const ReplaceAllACLDefaultsAcceptedCode int = 202

/*
ReplaceAllACLDefaultsAccepted Configuration change accepted and reload requested

swagger:response replaceAllAclDefaultsAccepted
*/
type ReplaceAllACLDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`

	/*
	  In: Body
	*/
	Payload models.Acls `json:"body,omitempty"`
}

// NewReplaceAllACLDefaultsAccepted creates ReplaceAllACLDefaultsAccepted with default headers values
func NewReplaceAllACLDefaultsAccepted() *ReplaceAllACLDefaultsAccepted {

	return &ReplaceAllACLDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the replace all Acl defaults accepted response
func (o *ReplaceAllACLDefaultsAccepted) WithReloadID(reloadID string) *ReplaceAllACLDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the replace all Acl defaults accepted response
func (o *ReplaceAllACLDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WithPayload adds the payload to the replace all Acl defaults accepted response
func (o *ReplaceAllACLDefaultsAccepted) WithPayload(payload models.Acls) *ReplaceAllACLDefaultsAccepted {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Acl defaults accepted response
func (o *ReplaceAllACLDefaultsAccepted) SetPayload(payload models.Acls) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllACLDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.WriteHeader(202)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.Acls{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllACLDefaultsBadRequestCode is the HTTP code returned for type ReplaceAllACLDefaultsBadRequest
const ReplaceAllACLDefaultsBadRequestCode int = 400

/*
ReplaceAllACLDefaultsBadRequest Bad request

swagger:response replaceAllAclDefaultsBadRequest
*/
type ReplaceAllACLDefaultsBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllACLDefaultsBadRequest creates ReplaceAllACLDefaultsBadRequest with default headers values
func NewReplaceAllACLDefaultsBadRequest() *ReplaceAllACLDefaultsBadRequest {

	return &ReplaceAllACLDefaultsBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the replace all Acl defaults bad request response
func (o *ReplaceAllACLDefaultsBadRequest) WithConfigurationVersion(configurationVersion string) *ReplaceAllACLDefaultsBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all Acl defaults bad request response
func (o *ReplaceAllACLDefaultsBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all Acl defaults bad request response
func (o *ReplaceAllACLDefaultsBadRequest) WithPayload(payload *models.Error) *ReplaceAllACLDefaultsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Acl defaults bad request response
func (o *ReplaceAllACLDefaultsBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllACLDefaultsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
ReplaceAllACLDefaultsDefault General Error

swagger:response replaceAllAclDefaultsDefault
*/
type ReplaceAllACLDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllACLDefaultsDefault creates ReplaceAllACLDefaultsDefault with default headers values
func NewReplaceAllACLDefaultsDefault(code int) *ReplaceAllACLDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &ReplaceAllACLDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the replace all Acl defaults default response
func (o *ReplaceAllACLDefaultsDefault) WithStatusCode(code int) *ReplaceAllACLDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the replace all Acl defaults default response
func (o *ReplaceAllACLDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the replace all Acl defaults default response
func (o *ReplaceAllACLDefaultsDefault) WithConfigurationVersion(configurationVersion string) *ReplaceAllACLDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all Acl defaults default response
func (o *ReplaceAllACLDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all Acl defaults default response
func (o *ReplaceAllACLDefaultsDefault) WithPayload(payload *models.Error) *ReplaceAllACLDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Acl defaults default response
func (o *ReplaceAllACLDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllACLDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
