// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acme

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAcmeProviderOKCode is the HTTP code returned for type GetAcmeProviderOK
const GetAcmeProviderOKCode int = 200

/*
GetAcmeProviderOK Successful operation

swagger:response getAcmeProviderOK
*/
type GetAcmeProviderOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.AcmeProvider `json:"body,omitempty"`
}

// NewGetAcmeProviderOK creates GetAcmeProviderOK with default headers values
func NewGetAcmeProviderOK() *GetAcmeProviderOK {

	return &GetAcmeProviderOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get acme provider o k response
func (o *GetAcmeProviderOK) WithConfigurationVersion(configurationVersion string) *GetAcmeProviderOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get acme provider o k response
func (o *GetAcmeProviderOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get acme provider o k response
func (o *GetAcmeProviderOK) WithPayload(payload *models.AcmeProvider) *GetAcmeProviderOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get acme provider o k response
func (o *GetAcmeProviderOK) SetPayload(payload *models.AcmeProvider) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAcmeProviderOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetAcmeProviderNotFoundCode is the HTTP code returned for type GetAcmeProviderNotFound
const GetAcmeProviderNotFoundCode int = 404

/*
GetAcmeProviderNotFound The specified resource was not found

swagger:response getAcmeProviderNotFound
*/
type GetAcmeProviderNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAcmeProviderNotFound creates GetAcmeProviderNotFound with default headers values
func NewGetAcmeProviderNotFound() *GetAcmeProviderNotFound {

	return &GetAcmeProviderNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get acme provider not found response
func (o *GetAcmeProviderNotFound) WithConfigurationVersion(configurationVersion string) *GetAcmeProviderNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get acme provider not found response
func (o *GetAcmeProviderNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get acme provider not found response
func (o *GetAcmeProviderNotFound) WithPayload(payload *models.Error) *GetAcmeProviderNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get acme provider not found response
func (o *GetAcmeProviderNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAcmeProviderNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetAcmeProviderDefault General Error

swagger:response getAcmeProviderDefault
*/
type GetAcmeProviderDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAcmeProviderDefault creates GetAcmeProviderDefault with default headers values
func NewGetAcmeProviderDefault(code int) *GetAcmeProviderDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAcmeProviderDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get acme provider default response
func (o *GetAcmeProviderDefault) WithStatusCode(code int) *GetAcmeProviderDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get acme provider default response
func (o *GetAcmeProviderDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get acme provider default response
func (o *GetAcmeProviderDefault) WithConfigurationVersion(configurationVersion string) *GetAcmeProviderDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get acme provider default response
func (o *GetAcmeProviderDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get acme provider default response
func (o *GetAcmeProviderDefault) WithPayload(payload *models.Error) *GetAcmeProviderDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get acme provider default response
func (o *GetAcmeProviderDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAcmeProviderDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
