// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acme

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAcmeProvidersOKCode is the HTTP code returned for type GetAcmeProvidersOK
const GetAcmeProvidersOKCode int = 200

/*
GetAcmeProvidersOK Successful operation

swagger:response getAcmeProvidersOK
*/
type GetAcmeProvidersOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.AcmeProviders `json:"body,omitempty"`
}

// NewGetAcmeProvidersOK creates GetAcmeProvidersOK with default headers values
func NewGetAcmeProvidersOK() *GetAcmeProvidersOK {

	return &GetAcmeProvidersOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get acme providers o k response
func (o *GetAcmeProvidersOK) WithConfigurationVersion(configurationVersion string) *GetAcmeProvidersOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get acme providers o k response
func (o *GetAcmeProvidersOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get acme providers o k response
func (o *GetAcmeProvidersOK) WithPayload(payload models.AcmeProviders) *GetAcmeProvidersOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get acme providers o k response
func (o *GetAcmeProvidersOK) SetPayload(payload models.AcmeProviders) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAcmeProvidersOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.AcmeProviders{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAcmeProvidersDefault General Error

swagger:response getAcmeProvidersDefault
*/
type GetAcmeProvidersDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAcmeProvidersDefault creates GetAcmeProvidersDefault with default headers values
func NewGetAcmeProvidersDefault(code int) *GetAcmeProvidersDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAcmeProvidersDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get acme providers default response
func (o *GetAcmeProvidersDefault) WithStatusCode(code int) *GetAcmeProvidersDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get acme providers default response
func (o *GetAcmeProvidersDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get acme providers default response
func (o *GetAcmeProvidersDefault) WithConfigurationVersion(configurationVersion string) *GetAcmeProvidersDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get acme providers default response
func (o *GetAcmeProvidersDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get acme providers default response
func (o *GetAcmeProvidersDefault) WithPayload(payload *models.Error) *GetAcmeProvidersDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get acme providers default response
func (o *GetAcmeProvidersDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAcmeProvidersDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
