// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_after_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllHTTPAfterResponseRuleDefaultsOKCode is the HTTP code returned for type GetAllHTTPAfterResponseRuleDefaultsOK
const GetAllHTTPAfterResponseRuleDefaultsOKCode int = 200

/*
GetAllHTTPAfterResponseRuleDefaultsOK Successful operation

swagger:response getAllHttpAfterResponseRuleDefaultsOK
*/
type GetAllHTTPAfterResponseRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.HTTPAfterResponseRules `json:"body,omitempty"`
}

// NewGetAllHTTPAfterResponseRuleDefaultsOK creates GetAllHTTPAfterResponseRuleDefaultsOK with default headers values
func NewGetAllHTTPAfterResponseRuleDefaultsOK() *GetAllHTTPAfterResponseRuleDefaultsOK {

	return &GetAllHTTPAfterResponseRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all Http after response rule defaults o k response
func (o *GetAllHTTPAfterResponseRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetAllHTTPAfterResponseRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all Http after response rule defaults o k response
func (o *GetAllHTTPAfterResponseRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all Http after response rule defaults o k response
func (o *GetAllHTTPAfterResponseRuleDefaultsOK) WithPayload(payload models.HTTPAfterResponseRules) *GetAllHTTPAfterResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all Http after response rule defaults o k response
func (o *GetAllHTTPAfterResponseRuleDefaultsOK) SetPayload(payload models.HTTPAfterResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllHTTPAfterResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPAfterResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllHTTPAfterResponseRuleDefaultsDefault General Error

swagger:response getAllHttpAfterResponseRuleDefaultsDefault
*/
type GetAllHTTPAfterResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllHTTPAfterResponseRuleDefaultsDefault creates GetAllHTTPAfterResponseRuleDefaultsDefault with default headers values
func NewGetAllHTTPAfterResponseRuleDefaultsDefault(code int) *GetAllHTTPAfterResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllHTTPAfterResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all HTTP after response rule defaults default response
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) WithStatusCode(code int) *GetAllHTTPAfterResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all HTTP after response rule defaults default response
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all HTTP after response rule defaults default response
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetAllHTTPAfterResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all HTTP after response rule defaults default response
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all HTTP after response rule defaults default response
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *GetAllHTTPAfterResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all HTTP after response rule defaults default response
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllHTTPAfterResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
