// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_after_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetHTTPAfterResponseRuleDefaultsOKCode is the HTTP code returned for type GetHTTPAfterResponseRuleDefaultsOK
const GetHTTPAfterResponseRuleDefaultsOKCode int = 200

/*
GetHTTPAfterResponseRuleDefaultsOK Successful operation

swagger:response getHttpAfterResponseRuleDefaultsOK
*/
type GetHTTPAfterResponseRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.HTTPAfterResponseRule `json:"body,omitempty"`
}

// NewGetHTTPAfterResponseRuleDefaultsOK creates GetHTTPAfterResponseRuleDefaultsOK with default headers values
func NewGetHTTPAfterResponseRuleDefaultsOK() *GetHTTPAfterResponseRuleDefaultsOK {

	return &GetHTTPAfterResponseRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http after response rule defaults o k response
func (o *GetHTTPAfterResponseRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetHTTPAfterResponseRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http after response rule defaults o k response
func (o *GetHTTPAfterResponseRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http after response rule defaults o k response
func (o *GetHTTPAfterResponseRuleDefaultsOK) WithPayload(payload *models.HTTPAfterResponseRule) *GetHTTPAfterResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http after response rule defaults o k response
func (o *GetHTTPAfterResponseRuleDefaultsOK) SetPayload(payload *models.HTTPAfterResponseRule) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPAfterResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetHTTPAfterResponseRuleDefaultsNotFoundCode is the HTTP code returned for type GetHTTPAfterResponseRuleDefaultsNotFound
const GetHTTPAfterResponseRuleDefaultsNotFoundCode int = 404

/*
GetHTTPAfterResponseRuleDefaultsNotFound The specified resource was not found

swagger:response getHttpAfterResponseRuleDefaultsNotFound
*/
type GetHTTPAfterResponseRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPAfterResponseRuleDefaultsNotFound creates GetHTTPAfterResponseRuleDefaultsNotFound with default headers values
func NewGetHTTPAfterResponseRuleDefaultsNotFound() *GetHTTPAfterResponseRuleDefaultsNotFound {

	return &GetHTTPAfterResponseRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http after response rule defaults not found response
func (o *GetHTTPAfterResponseRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *GetHTTPAfterResponseRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http after response rule defaults not found response
func (o *GetHTTPAfterResponseRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http after response rule defaults not found response
func (o *GetHTTPAfterResponseRuleDefaultsNotFound) WithPayload(payload *models.Error) *GetHTTPAfterResponseRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http after response rule defaults not found response
func (o *GetHTTPAfterResponseRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPAfterResponseRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetHTTPAfterResponseRuleDefaultsDefault General Error

swagger:response getHttpAfterResponseRuleDefaultsDefault
*/
type GetHTTPAfterResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPAfterResponseRuleDefaultsDefault creates GetHTTPAfterResponseRuleDefaultsDefault with default headers values
func NewGetHTTPAfterResponseRuleDefaultsDefault(code int) *GetHTTPAfterResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetHTTPAfterResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get HTTP after response rule defaults default response
func (o *GetHTTPAfterResponseRuleDefaultsDefault) WithStatusCode(code int) *GetHTTPAfterResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get HTTP after response rule defaults default response
func (o *GetHTTPAfterResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get HTTP after response rule defaults default response
func (o *GetHTTPAfterResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetHTTPAfterResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get HTTP after response rule defaults default response
func (o *GetHTTPAfterResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get HTTP after response rule defaults default response
func (o *GetHTTPAfterResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *GetHTTPAfterResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get HTTP after response rule defaults default response
func (o *GetHTTPAfterResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPAfterResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
