// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_after_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// ReplaceAllHTTPAfterResponseRuleDefaultsOKCode is the HTTP code returned for type ReplaceAllHTTPAfterResponseRuleDefaultsOK
const ReplaceAllHTTPAfterResponseRuleDefaultsOKCode int = 200

/*
ReplaceAllHTTPAfterResponseRuleDefaultsOK All TTP After Response Rules lines replaced

swagger:response replaceAllHttpAfterResponseRuleDefaultsOK
*/
type ReplaceAllHTTPAfterResponseRuleDefaultsOK struct {

	/*
	  In: Body
	*/
	Payload models.HTTPAfterResponseRules `json:"body,omitempty"`
}

// NewReplaceAllHTTPAfterResponseRuleDefaultsOK creates ReplaceAllHTTPAfterResponseRuleDefaultsOK with default headers values
func NewReplaceAllHTTPAfterResponseRuleDefaultsOK() *ReplaceAllHTTPAfterResponseRuleDefaultsOK {

	return &ReplaceAllHTTPAfterResponseRuleDefaultsOK{}
}

// WithPayload adds the payload to the replace all Http after response rule defaults o k response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsOK) WithPayload(payload models.HTTPAfterResponseRules) *ReplaceAllHTTPAfterResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http after response rule defaults o k response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsOK) SetPayload(payload models.HTTPAfterResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPAfterResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllHTTPAfterResponseRuleDefaultsAcceptedCode is the HTTP code returned for type ReplaceAllHTTPAfterResponseRuleDefaultsAccepted
const ReplaceAllHTTPAfterResponseRuleDefaultsAcceptedCode int = 202

/*
ReplaceAllHTTPAfterResponseRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response replaceAllHttpAfterResponseRuleDefaultsAccepted
*/
type ReplaceAllHTTPAfterResponseRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`

	/*
	  In: Body
	*/
	Payload models.HTTPAfterResponseRules `json:"body,omitempty"`
}

// NewReplaceAllHTTPAfterResponseRuleDefaultsAccepted creates ReplaceAllHTTPAfterResponseRuleDefaultsAccepted with default headers values
func NewReplaceAllHTTPAfterResponseRuleDefaultsAccepted() *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted {

	return &ReplaceAllHTTPAfterResponseRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the replace all Http after response rule defaults accepted response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted) WithReloadID(reloadID string) *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the replace all Http after response rule defaults accepted response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WithPayload adds the payload to the replace all Http after response rule defaults accepted response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted) WithPayload(payload models.HTTPAfterResponseRules) *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http after response rule defaults accepted response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted) SetPayload(payload models.HTTPAfterResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.WriteHeader(202)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPAfterResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllHTTPAfterResponseRuleDefaultsBadRequestCode is the HTTP code returned for type ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest
const ReplaceAllHTTPAfterResponseRuleDefaultsBadRequestCode int = 400

/*
ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest Bad request

swagger:response replaceAllHttpAfterResponseRuleDefaultsBadRequest
*/
type ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllHTTPAfterResponseRuleDefaultsBadRequest creates ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest with default headers values
func NewReplaceAllHTTPAfterResponseRuleDefaultsBadRequest() *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest {

	return &ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the replace all Http after response rule defaults bad request response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest) WithConfigurationVersion(configurationVersion string) *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all Http after response rule defaults bad request response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all Http after response rule defaults bad request response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest) WithPayload(payload *models.Error) *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http after response rule defaults bad request response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
ReplaceAllHTTPAfterResponseRuleDefaultsDefault General Error

swagger:response replaceAllHttpAfterResponseRuleDefaultsDefault
*/
type ReplaceAllHTTPAfterResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllHTTPAfterResponseRuleDefaultsDefault creates ReplaceAllHTTPAfterResponseRuleDefaultsDefault with default headers values
func NewReplaceAllHTTPAfterResponseRuleDefaultsDefault(code int) *ReplaceAllHTTPAfterResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &ReplaceAllHTTPAfterResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the replace all HTTP after response rule defaults default response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) WithStatusCode(code int) *ReplaceAllHTTPAfterResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the replace all HTTP after response rule defaults default response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the replace all HTTP after response rule defaults default response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *ReplaceAllHTTPAfterResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all HTTP after response rule defaults default response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all HTTP after response rule defaults default response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *ReplaceAllHTTPAfterResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all HTTP after response rule defaults default response
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPAfterResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
