// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteHTTPRequestRuleDefaultsAcceptedCode is the HTTP code returned for type DeleteHTTPRequestRuleDefaultsAccepted
const DeleteHTTPRequestRuleDefaultsAcceptedCode int = 202

/*
DeleteHTTPRequestRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response deleteHttpRequestRuleDefaultsAccepted
*/
type DeleteHTTPRequestRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteHTTPRequestRuleDefaultsAccepted creates DeleteHTTPRequestRuleDefaultsAccepted with default headers values
func NewDeleteHTTPRequestRuleDefaultsAccepted() *DeleteHTTPRequestRuleDefaultsAccepted {

	return &DeleteHTTPRequestRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the delete Http request rule defaults accepted response
func (o *DeleteHTTPRequestRuleDefaultsAccepted) WithReloadID(reloadID string) *DeleteHTTPRequestRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete Http request rule defaults accepted response
func (o *DeleteHTTPRequestRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteHTTPRequestRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteHTTPRequestRuleDefaultsNoContentCode is the HTTP code returned for type DeleteHTTPRequestRuleDefaultsNoContent
const DeleteHTTPRequestRuleDefaultsNoContentCode int = 204

/*
DeleteHTTPRequestRuleDefaultsNoContent HTTP Request Rule deleted

swagger:response deleteHttpRequestRuleDefaultsNoContent
*/
type DeleteHTTPRequestRuleDefaultsNoContent struct {
}

// NewDeleteHTTPRequestRuleDefaultsNoContent creates DeleteHTTPRequestRuleDefaultsNoContent with default headers values
func NewDeleteHTTPRequestRuleDefaultsNoContent() *DeleteHTTPRequestRuleDefaultsNoContent {

	return &DeleteHTTPRequestRuleDefaultsNoContent{}
}

// WriteResponse to the client
func (o *DeleteHTTPRequestRuleDefaultsNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteHTTPRequestRuleDefaultsNotFoundCode is the HTTP code returned for type DeleteHTTPRequestRuleDefaultsNotFound
const DeleteHTTPRequestRuleDefaultsNotFoundCode int = 404

/*
DeleteHTTPRequestRuleDefaultsNotFound The specified resource was not found

swagger:response deleteHttpRequestRuleDefaultsNotFound
*/
type DeleteHTTPRequestRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteHTTPRequestRuleDefaultsNotFound creates DeleteHTTPRequestRuleDefaultsNotFound with default headers values
func NewDeleteHTTPRequestRuleDefaultsNotFound() *DeleteHTTPRequestRuleDefaultsNotFound {

	return &DeleteHTTPRequestRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete Http request rule defaults not found response
func (o *DeleteHTTPRequestRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *DeleteHTTPRequestRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Http request rule defaults not found response
func (o *DeleteHTTPRequestRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Http request rule defaults not found response
func (o *DeleteHTTPRequestRuleDefaultsNotFound) WithPayload(payload *models.Error) *DeleteHTTPRequestRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Http request rule defaults not found response
func (o *DeleteHTTPRequestRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteHTTPRequestRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteHTTPRequestRuleDefaultsDefault General Error

swagger:response deleteHttpRequestRuleDefaultsDefault
*/
type DeleteHTTPRequestRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteHTTPRequestRuleDefaultsDefault creates DeleteHTTPRequestRuleDefaultsDefault with default headers values
func NewDeleteHTTPRequestRuleDefaultsDefault(code int) *DeleteHTTPRequestRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteHTTPRequestRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete HTTP request rule defaults default response
func (o *DeleteHTTPRequestRuleDefaultsDefault) WithStatusCode(code int) *DeleteHTTPRequestRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete HTTP request rule defaults default response
func (o *DeleteHTTPRequestRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete HTTP request rule defaults default response
func (o *DeleteHTTPRequestRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *DeleteHTTPRequestRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete HTTP request rule defaults default response
func (o *DeleteHTTPRequestRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete HTTP request rule defaults default response
func (o *DeleteHTTPRequestRuleDefaultsDefault) WithPayload(payload *models.Error) *DeleteHTTPRequestRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete HTTP request rule defaults default response
func (o *DeleteHTTPRequestRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteHTTPRequestRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
