// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllHTTPRequestRuleDefaultsOKCode is the HTTP code returned for type GetAllHTTPRequestRuleDefaultsOK
const GetAllHTTPRequestRuleDefaultsOKCode int = 200

/*
GetAllHTTPRequestRuleDefaultsOK Successful operation

swagger:response getAllHttpRequestRuleDefaultsOK
*/
type GetAllHTTPRequestRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.HTTPRequestRules `json:"body,omitempty"`
}

// NewGetAllHTTPRequestRuleDefaultsOK creates GetAllHTTPRequestRuleDefaultsOK with default headers values
func NewGetAllHTTPRequestRuleDefaultsOK() *GetAllHTTPRequestRuleDefaultsOK {

	return &GetAllHTTPRequestRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all Http request rule defaults o k response
func (o *GetAllHTTPRequestRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetAllHTTPRequestRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all Http request rule defaults o k response
func (o *GetAllHTTPRequestRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all Http request rule defaults o k response
func (o *GetAllHTTPRequestRuleDefaultsOK) WithPayload(payload models.HTTPRequestRules) *GetAllHTTPRequestRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all Http request rule defaults o k response
func (o *GetAllHTTPRequestRuleDefaultsOK) SetPayload(payload models.HTTPRequestRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllHTTPRequestRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPRequestRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllHTTPRequestRuleDefaultsDefault General Error

swagger:response getAllHttpRequestRuleDefaultsDefault
*/
type GetAllHTTPRequestRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllHTTPRequestRuleDefaultsDefault creates GetAllHTTPRequestRuleDefaultsDefault with default headers values
func NewGetAllHTTPRequestRuleDefaultsDefault(code int) *GetAllHTTPRequestRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllHTTPRequestRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all HTTP request rule defaults default response
func (o *GetAllHTTPRequestRuleDefaultsDefault) WithStatusCode(code int) *GetAllHTTPRequestRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all HTTP request rule defaults default response
func (o *GetAllHTTPRequestRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all HTTP request rule defaults default response
func (o *GetAllHTTPRequestRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetAllHTTPRequestRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all HTTP request rule defaults default response
func (o *GetAllHTTPRequestRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all HTTP request rule defaults default response
func (o *GetAllHTTPRequestRuleDefaultsDefault) WithPayload(payload *models.Error) *GetAllHTTPRequestRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all HTTP request rule defaults default response
func (o *GetAllHTTPRequestRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllHTTPRequestRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
