// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetHTTPRequestRuleDefaultsOKCode is the HTTP code returned for type GetHTTPRequestRuleDefaultsOK
const GetHTTPRequestRuleDefaultsOKCode int = 200

/*
GetHTTPRequestRuleDefaultsOK Successful operation

swagger:response getHttpRequestRuleDefaultsOK
*/
type GetHTTPRequestRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.HTTPRequestRule `json:"body,omitempty"`
}

// NewGetHTTPRequestRuleDefaultsOK creates GetHTTPRequestRuleDefaultsOK with default headers values
func NewGetHTTPRequestRuleDefaultsOK() *GetHTTPRequestRuleDefaultsOK {

	return &GetHTTPRequestRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http request rule defaults o k response
func (o *GetHTTPRequestRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetHTTPRequestRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http request rule defaults o k response
func (o *GetHTTPRequestRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http request rule defaults o k response
func (o *GetHTTPRequestRuleDefaultsOK) WithPayload(payload *models.HTTPRequestRule) *GetHTTPRequestRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http request rule defaults o k response
func (o *GetHTTPRequestRuleDefaultsOK) SetPayload(payload *models.HTTPRequestRule) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPRequestRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetHTTPRequestRuleDefaultsNotFoundCode is the HTTP code returned for type GetHTTPRequestRuleDefaultsNotFound
const GetHTTPRequestRuleDefaultsNotFoundCode int = 404

/*
GetHTTPRequestRuleDefaultsNotFound The specified resource was not found

swagger:response getHttpRequestRuleDefaultsNotFound
*/
type GetHTTPRequestRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPRequestRuleDefaultsNotFound creates GetHTTPRequestRuleDefaultsNotFound with default headers values
func NewGetHTTPRequestRuleDefaultsNotFound() *GetHTTPRequestRuleDefaultsNotFound {

	return &GetHTTPRequestRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http request rule defaults not found response
func (o *GetHTTPRequestRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *GetHTTPRequestRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http request rule defaults not found response
func (o *GetHTTPRequestRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http request rule defaults not found response
func (o *GetHTTPRequestRuleDefaultsNotFound) WithPayload(payload *models.Error) *GetHTTPRequestRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http request rule defaults not found response
func (o *GetHTTPRequestRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPRequestRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetHTTPRequestRuleDefaultsDefault General Error

swagger:response getHttpRequestRuleDefaultsDefault
*/
type GetHTTPRequestRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPRequestRuleDefaultsDefault creates GetHTTPRequestRuleDefaultsDefault with default headers values
func NewGetHTTPRequestRuleDefaultsDefault(code int) *GetHTTPRequestRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetHTTPRequestRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get HTTP request rule defaults default response
func (o *GetHTTPRequestRuleDefaultsDefault) WithStatusCode(code int) *GetHTTPRequestRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get HTTP request rule defaults default response
func (o *GetHTTPRequestRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get HTTP request rule defaults default response
func (o *GetHTTPRequestRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetHTTPRequestRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get HTTP request rule defaults default response
func (o *GetHTTPRequestRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get HTTP request rule defaults default response
func (o *GetHTTPRequestRuleDefaultsDefault) WithPayload(payload *models.Error) *GetHTTPRequestRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get HTTP request rule defaults default response
func (o *GetHTTPRequestRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPRequestRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
