// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// ReplaceAllHTTPRequestRuleDefaultsOKCode is the HTTP code returned for type ReplaceAllHTTPRequestRuleDefaultsOK
const ReplaceAllHTTPRequestRuleDefaultsOKCode int = 200

/*
ReplaceAllHTTPRequestRuleDefaultsOK All HTTP Request Rule lines replaced

swagger:response replaceAllHttpRequestRuleDefaultsOK
*/
type ReplaceAllHTTPRequestRuleDefaultsOK struct {

	/*
	  In: Body
	*/
	Payload models.HTTPRequestRules `json:"body,omitempty"`
}

// NewReplaceAllHTTPRequestRuleDefaultsOK creates ReplaceAllHTTPRequestRuleDefaultsOK with default headers values
func NewReplaceAllHTTPRequestRuleDefaultsOK() *ReplaceAllHTTPRequestRuleDefaultsOK {

	return &ReplaceAllHTTPRequestRuleDefaultsOK{}
}

// WithPayload adds the payload to the replace all Http request rule defaults o k response
func (o *ReplaceAllHTTPRequestRuleDefaultsOK) WithPayload(payload models.HTTPRequestRules) *ReplaceAllHTTPRequestRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http request rule defaults o k response
func (o *ReplaceAllHTTPRequestRuleDefaultsOK) SetPayload(payload models.HTTPRequestRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPRequestRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPRequestRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllHTTPRequestRuleDefaultsAcceptedCode is the HTTP code returned for type ReplaceAllHTTPRequestRuleDefaultsAccepted
const ReplaceAllHTTPRequestRuleDefaultsAcceptedCode int = 202

/*
ReplaceAllHTTPRequestRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response replaceAllHttpRequestRuleDefaultsAccepted
*/
type ReplaceAllHTTPRequestRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`

	/*
	  In: Body
	*/
	Payload models.HTTPRequestRules `json:"body,omitempty"`
}

// NewReplaceAllHTTPRequestRuleDefaultsAccepted creates ReplaceAllHTTPRequestRuleDefaultsAccepted with default headers values
func NewReplaceAllHTTPRequestRuleDefaultsAccepted() *ReplaceAllHTTPRequestRuleDefaultsAccepted {

	return &ReplaceAllHTTPRequestRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the replace all Http request rule defaults accepted response
func (o *ReplaceAllHTTPRequestRuleDefaultsAccepted) WithReloadID(reloadID string) *ReplaceAllHTTPRequestRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the replace all Http request rule defaults accepted response
func (o *ReplaceAllHTTPRequestRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WithPayload adds the payload to the replace all Http request rule defaults accepted response
func (o *ReplaceAllHTTPRequestRuleDefaultsAccepted) WithPayload(payload models.HTTPRequestRules) *ReplaceAllHTTPRequestRuleDefaultsAccepted {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http request rule defaults accepted response
func (o *ReplaceAllHTTPRequestRuleDefaultsAccepted) SetPayload(payload models.HTTPRequestRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPRequestRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.WriteHeader(202)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPRequestRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllHTTPRequestRuleDefaultsBadRequestCode is the HTTP code returned for type ReplaceAllHTTPRequestRuleDefaultsBadRequest
const ReplaceAllHTTPRequestRuleDefaultsBadRequestCode int = 400

/*
ReplaceAllHTTPRequestRuleDefaultsBadRequest Bad request

swagger:response replaceAllHttpRequestRuleDefaultsBadRequest
*/
type ReplaceAllHTTPRequestRuleDefaultsBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllHTTPRequestRuleDefaultsBadRequest creates ReplaceAllHTTPRequestRuleDefaultsBadRequest with default headers values
func NewReplaceAllHTTPRequestRuleDefaultsBadRequest() *ReplaceAllHTTPRequestRuleDefaultsBadRequest {

	return &ReplaceAllHTTPRequestRuleDefaultsBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the replace all Http request rule defaults bad request response
func (o *ReplaceAllHTTPRequestRuleDefaultsBadRequest) WithConfigurationVersion(configurationVersion string) *ReplaceAllHTTPRequestRuleDefaultsBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all Http request rule defaults bad request response
func (o *ReplaceAllHTTPRequestRuleDefaultsBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all Http request rule defaults bad request response
func (o *ReplaceAllHTTPRequestRuleDefaultsBadRequest) WithPayload(payload *models.Error) *ReplaceAllHTTPRequestRuleDefaultsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http request rule defaults bad request response
func (o *ReplaceAllHTTPRequestRuleDefaultsBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPRequestRuleDefaultsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
ReplaceAllHTTPRequestRuleDefaultsDefault General Error

swagger:response replaceAllHttpRequestRuleDefaultsDefault
*/
type ReplaceAllHTTPRequestRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllHTTPRequestRuleDefaultsDefault creates ReplaceAllHTTPRequestRuleDefaultsDefault with default headers values
func NewReplaceAllHTTPRequestRuleDefaultsDefault(code int) *ReplaceAllHTTPRequestRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &ReplaceAllHTTPRequestRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the replace all HTTP request rule defaults default response
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) WithStatusCode(code int) *ReplaceAllHTTPRequestRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the replace all HTTP request rule defaults default response
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the replace all HTTP request rule defaults default response
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *ReplaceAllHTTPRequestRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all HTTP request rule defaults default response
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all HTTP request rule defaults default response
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) WithPayload(payload *models.Error) *ReplaceAllHTTPRequestRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all HTTP request rule defaults default response
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPRequestRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
