// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteHTTPResponseRuleDefaultsAcceptedCode is the HTTP code returned for type DeleteHTTPResponseRuleDefaultsAccepted
const DeleteHTTPResponseRuleDefaultsAcceptedCode int = 202

/*
DeleteHTTPResponseRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response deleteHttpResponseRuleDefaultsAccepted
*/
type DeleteHTTPResponseRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteHTTPResponseRuleDefaultsAccepted creates DeleteHTTPResponseRuleDefaultsAccepted with default headers values
func NewDeleteHTTPResponseRuleDefaultsAccepted() *DeleteHTTPResponseRuleDefaultsAccepted {

	return &DeleteHTTPResponseRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the delete Http response rule defaults accepted response
func (o *DeleteHTTPResponseRuleDefaultsAccepted) WithReloadID(reloadID string) *DeleteHTTPResponseRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete Http response rule defaults accepted response
func (o *DeleteHTTPResponseRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteHTTPResponseRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteHTTPResponseRuleDefaultsNoContentCode is the HTTP code returned for type DeleteHTTPResponseRuleDefaultsNoContent
const DeleteHTTPResponseRuleDefaultsNoContentCode int = 204

/*
DeleteHTTPResponseRuleDefaultsNoContent HTTP Response Rule deleted

swagger:response deleteHttpResponseRuleDefaultsNoContent
*/
type DeleteHTTPResponseRuleDefaultsNoContent struct {
}

// NewDeleteHTTPResponseRuleDefaultsNoContent creates DeleteHTTPResponseRuleDefaultsNoContent with default headers values
func NewDeleteHTTPResponseRuleDefaultsNoContent() *DeleteHTTPResponseRuleDefaultsNoContent {

	return &DeleteHTTPResponseRuleDefaultsNoContent{}
}

// WriteResponse to the client
func (o *DeleteHTTPResponseRuleDefaultsNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteHTTPResponseRuleDefaultsNotFoundCode is the HTTP code returned for type DeleteHTTPResponseRuleDefaultsNotFound
const DeleteHTTPResponseRuleDefaultsNotFoundCode int = 404

/*
DeleteHTTPResponseRuleDefaultsNotFound The specified resource was not found

swagger:response deleteHttpResponseRuleDefaultsNotFound
*/
type DeleteHTTPResponseRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteHTTPResponseRuleDefaultsNotFound creates DeleteHTTPResponseRuleDefaultsNotFound with default headers values
func NewDeleteHTTPResponseRuleDefaultsNotFound() *DeleteHTTPResponseRuleDefaultsNotFound {

	return &DeleteHTTPResponseRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete Http response rule defaults not found response
func (o *DeleteHTTPResponseRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *DeleteHTTPResponseRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Http response rule defaults not found response
func (o *DeleteHTTPResponseRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Http response rule defaults not found response
func (o *DeleteHTTPResponseRuleDefaultsNotFound) WithPayload(payload *models.Error) *DeleteHTTPResponseRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Http response rule defaults not found response
func (o *DeleteHTTPResponseRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteHTTPResponseRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteHTTPResponseRuleDefaultsDefault General Error

swagger:response deleteHttpResponseRuleDefaultsDefault
*/
type DeleteHTTPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteHTTPResponseRuleDefaultsDefault creates DeleteHTTPResponseRuleDefaultsDefault with default headers values
func NewDeleteHTTPResponseRuleDefaultsDefault(code int) *DeleteHTTPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteHTTPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete HTTP response rule defaults default response
func (o *DeleteHTTPResponseRuleDefaultsDefault) WithStatusCode(code int) *DeleteHTTPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete HTTP response rule defaults default response
func (o *DeleteHTTPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete HTTP response rule defaults default response
func (o *DeleteHTTPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *DeleteHTTPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete HTTP response rule defaults default response
func (o *DeleteHTTPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete HTTP response rule defaults default response
func (o *DeleteHTTPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *DeleteHTTPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete HTTP response rule defaults default response
func (o *DeleteHTTPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteHTTPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
