// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllHTTPResponseRuleDefaultsOKCode is the HTTP code returned for type GetAllHTTPResponseRuleDefaultsOK
const GetAllHTTPResponseRuleDefaultsOKCode int = 200

/*
GetAllHTTPResponseRuleDefaultsOK Successful operation

swagger:response getAllHttpResponseRuleDefaultsOK
*/
type GetAllHTTPResponseRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.HTTPResponseRules `json:"body,omitempty"`
}

// NewGetAllHTTPResponseRuleDefaultsOK creates GetAllHTTPResponseRuleDefaultsOK with default headers values
func NewGetAllHTTPResponseRuleDefaultsOK() *GetAllHTTPResponseRuleDefaultsOK {

	return &GetAllHTTPResponseRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all Http response rule defaults o k response
func (o *GetAllHTTPResponseRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetAllHTTPResponseRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all Http response rule defaults o k response
func (o *GetAllHTTPResponseRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all Http response rule defaults o k response
func (o *GetAllHTTPResponseRuleDefaultsOK) WithPayload(payload models.HTTPResponseRules) *GetAllHTTPResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all Http response rule defaults o k response
func (o *GetAllHTTPResponseRuleDefaultsOK) SetPayload(payload models.HTTPResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllHTTPResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllHTTPResponseRuleDefaultsDefault General Error

swagger:response getAllHttpResponseRuleDefaultsDefault
*/
type GetAllHTTPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllHTTPResponseRuleDefaultsDefault creates GetAllHTTPResponseRuleDefaultsDefault with default headers values
func NewGetAllHTTPResponseRuleDefaultsDefault(code int) *GetAllHTTPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllHTTPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all HTTP response rule defaults default response
func (o *GetAllHTTPResponseRuleDefaultsDefault) WithStatusCode(code int) *GetAllHTTPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all HTTP response rule defaults default response
func (o *GetAllHTTPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all HTTP response rule defaults default response
func (o *GetAllHTTPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetAllHTTPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all HTTP response rule defaults default response
func (o *GetAllHTTPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all HTTP response rule defaults default response
func (o *GetAllHTTPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *GetAllHTTPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all HTTP response rule defaults default response
func (o *GetAllHTTPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllHTTPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
