// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetHTTPResponseRuleDefaultsOKCode is the HTTP code returned for type GetHTTPResponseRuleDefaultsOK
const GetHTTPResponseRuleDefaultsOKCode int = 200

/*
GetHTTPResponseRuleDefaultsOK Successful operation

swagger:response getHttpResponseRuleDefaultsOK
*/
type GetHTTPResponseRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.HTTPResponseRule `json:"body,omitempty"`
}

// NewGetHTTPResponseRuleDefaultsOK creates GetHTTPResponseRuleDefaultsOK with default headers values
func NewGetHTTPResponseRuleDefaultsOK() *GetHTTPResponseRuleDefaultsOK {

	return &GetHTTPResponseRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http response rule defaults o k response
func (o *GetHTTPResponseRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetHTTPResponseRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http response rule defaults o k response
func (o *GetHTTPResponseRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http response rule defaults o k response
func (o *GetHTTPResponseRuleDefaultsOK) WithPayload(payload *models.HTTPResponseRule) *GetHTTPResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http response rule defaults o k response
func (o *GetHTTPResponseRuleDefaultsOK) SetPayload(payload *models.HTTPResponseRule) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetHTTPResponseRuleDefaultsNotFoundCode is the HTTP code returned for type GetHTTPResponseRuleDefaultsNotFound
const GetHTTPResponseRuleDefaultsNotFoundCode int = 404

/*
GetHTTPResponseRuleDefaultsNotFound The specified resource was not found

swagger:response getHttpResponseRuleDefaultsNotFound
*/
type GetHTTPResponseRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPResponseRuleDefaultsNotFound creates GetHTTPResponseRuleDefaultsNotFound with default headers values
func NewGetHTTPResponseRuleDefaultsNotFound() *GetHTTPResponseRuleDefaultsNotFound {

	return &GetHTTPResponseRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http response rule defaults not found response
func (o *GetHTTPResponseRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *GetHTTPResponseRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http response rule defaults not found response
func (o *GetHTTPResponseRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http response rule defaults not found response
func (o *GetHTTPResponseRuleDefaultsNotFound) WithPayload(payload *models.Error) *GetHTTPResponseRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http response rule defaults not found response
func (o *GetHTTPResponseRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPResponseRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetHTTPResponseRuleDefaultsDefault General Error

swagger:response getHttpResponseRuleDefaultsDefault
*/
type GetHTTPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPResponseRuleDefaultsDefault creates GetHTTPResponseRuleDefaultsDefault with default headers values
func NewGetHTTPResponseRuleDefaultsDefault(code int) *GetHTTPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetHTTPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get HTTP response rule defaults default response
func (o *GetHTTPResponseRuleDefaultsDefault) WithStatusCode(code int) *GetHTTPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get HTTP response rule defaults default response
func (o *GetHTTPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get HTTP response rule defaults default response
func (o *GetHTTPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetHTTPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get HTTP response rule defaults default response
func (o *GetHTTPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get HTTP response rule defaults default response
func (o *GetHTTPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *GetHTTPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get HTTP response rule defaults default response
func (o *GetHTTPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
