// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// ReplaceAllHTTPResponseRuleDefaultsOKCode is the HTTP code returned for type ReplaceAllHTTPResponseRuleDefaultsOK
const ReplaceAllHTTPResponseRuleDefaultsOKCode int = 200

/*
ReplaceAllHTTPResponseRuleDefaultsOK All HTTP Response Rule lines replaced

swagger:response replaceAllHttpResponseRuleDefaultsOK
*/
type ReplaceAllHTTPResponseRuleDefaultsOK struct {

	/*
	  In: Body
	*/
	Payload models.HTTPResponseRules `json:"body,omitempty"`
}

// NewReplaceAllHTTPResponseRuleDefaultsOK creates ReplaceAllHTTPResponseRuleDefaultsOK with default headers values
func NewReplaceAllHTTPResponseRuleDefaultsOK() *ReplaceAllHTTPResponseRuleDefaultsOK {

	return &ReplaceAllHTTPResponseRuleDefaultsOK{}
}

// WithPayload adds the payload to the replace all Http response rule defaults o k response
func (o *ReplaceAllHTTPResponseRuleDefaultsOK) WithPayload(payload models.HTTPResponseRules) *ReplaceAllHTTPResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http response rule defaults o k response
func (o *ReplaceAllHTTPResponseRuleDefaultsOK) SetPayload(payload models.HTTPResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllHTTPResponseRuleDefaultsAcceptedCode is the HTTP code returned for type ReplaceAllHTTPResponseRuleDefaultsAccepted
const ReplaceAllHTTPResponseRuleDefaultsAcceptedCode int = 202

/*
ReplaceAllHTTPResponseRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response replaceAllHttpResponseRuleDefaultsAccepted
*/
type ReplaceAllHTTPResponseRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`

	/*
	  In: Body
	*/
	Payload models.HTTPResponseRules `json:"body,omitempty"`
}

// NewReplaceAllHTTPResponseRuleDefaultsAccepted creates ReplaceAllHTTPResponseRuleDefaultsAccepted with default headers values
func NewReplaceAllHTTPResponseRuleDefaultsAccepted() *ReplaceAllHTTPResponseRuleDefaultsAccepted {

	return &ReplaceAllHTTPResponseRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the replace all Http response rule defaults accepted response
func (o *ReplaceAllHTTPResponseRuleDefaultsAccepted) WithReloadID(reloadID string) *ReplaceAllHTTPResponseRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the replace all Http response rule defaults accepted response
func (o *ReplaceAllHTTPResponseRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WithPayload adds the payload to the replace all Http response rule defaults accepted response
func (o *ReplaceAllHTTPResponseRuleDefaultsAccepted) WithPayload(payload models.HTTPResponseRules) *ReplaceAllHTTPResponseRuleDefaultsAccepted {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http response rule defaults accepted response
func (o *ReplaceAllHTTPResponseRuleDefaultsAccepted) SetPayload(payload models.HTTPResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPResponseRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.WriteHeader(202)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.HTTPResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// ReplaceAllHTTPResponseRuleDefaultsBadRequestCode is the HTTP code returned for type ReplaceAllHTTPResponseRuleDefaultsBadRequest
const ReplaceAllHTTPResponseRuleDefaultsBadRequestCode int = 400

/*
ReplaceAllHTTPResponseRuleDefaultsBadRequest Bad request

swagger:response replaceAllHttpResponseRuleDefaultsBadRequest
*/
type ReplaceAllHTTPResponseRuleDefaultsBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllHTTPResponseRuleDefaultsBadRequest creates ReplaceAllHTTPResponseRuleDefaultsBadRequest with default headers values
func NewReplaceAllHTTPResponseRuleDefaultsBadRequest() *ReplaceAllHTTPResponseRuleDefaultsBadRequest {

	return &ReplaceAllHTTPResponseRuleDefaultsBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the replace all Http response rule defaults bad request response
func (o *ReplaceAllHTTPResponseRuleDefaultsBadRequest) WithConfigurationVersion(configurationVersion string) *ReplaceAllHTTPResponseRuleDefaultsBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all Http response rule defaults bad request response
func (o *ReplaceAllHTTPResponseRuleDefaultsBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all Http response rule defaults bad request response
func (o *ReplaceAllHTTPResponseRuleDefaultsBadRequest) WithPayload(payload *models.Error) *ReplaceAllHTTPResponseRuleDefaultsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all Http response rule defaults bad request response
func (o *ReplaceAllHTTPResponseRuleDefaultsBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPResponseRuleDefaultsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
ReplaceAllHTTPResponseRuleDefaultsDefault General Error

swagger:response replaceAllHttpResponseRuleDefaultsDefault
*/
type ReplaceAllHTTPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceAllHTTPResponseRuleDefaultsDefault creates ReplaceAllHTTPResponseRuleDefaultsDefault with default headers values
func NewReplaceAllHTTPResponseRuleDefaultsDefault(code int) *ReplaceAllHTTPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &ReplaceAllHTTPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the replace all HTTP response rule defaults default response
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) WithStatusCode(code int) *ReplaceAllHTTPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the replace all HTTP response rule defaults default response
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the replace all HTTP response rule defaults default response
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *ReplaceAllHTTPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace all HTTP response rule defaults default response
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace all HTTP response rule defaults default response
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *ReplaceAllHTTPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace all HTTP response rule defaults default response
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceAllHTTPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
