// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_front_use

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllSSLFrontUsesOKCode is the HTTP code returned for type GetAllSSLFrontUsesOK
const GetAllSSLFrontUsesOKCode int = 200

/*
GetAllSSLFrontUsesOK Successful operation

swagger:response getAllSSLFrontUsesOK
*/
type GetAllSSLFrontUsesOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.SSLFrontUses `json:"body,omitempty"`
}

// NewGetAllSSLFrontUsesOK creates GetAllSSLFrontUsesOK with default headers values
func NewGetAllSSLFrontUsesOK() *GetAllSSLFrontUsesOK {

	return &GetAllSSLFrontUsesOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all s s l front uses o k response
func (o *GetAllSSLFrontUsesOK) WithConfigurationVersion(configurationVersion string) *GetAllSSLFrontUsesOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all s s l front uses o k response
func (o *GetAllSSLFrontUsesOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all s s l front uses o k response
func (o *GetAllSSLFrontUsesOK) WithPayload(payload models.SSLFrontUses) *GetAllSSLFrontUsesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all s s l front uses o k response
func (o *GetAllSSLFrontUsesOK) SetPayload(payload models.SSLFrontUses) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllSSLFrontUsesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SSLFrontUses{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllSSLFrontUsesDefault General Error

swagger:response getAllSSLFrontUsesDefault
*/
type GetAllSSLFrontUsesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllSSLFrontUsesDefault creates GetAllSSLFrontUsesDefault with default headers values
func NewGetAllSSLFrontUsesDefault(code int) *GetAllSSLFrontUsesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllSSLFrontUsesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all s s l front uses default response
func (o *GetAllSSLFrontUsesDefault) WithStatusCode(code int) *GetAllSSLFrontUsesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all s s l front uses default response
func (o *GetAllSSLFrontUsesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all s s l front uses default response
func (o *GetAllSSLFrontUsesDefault) WithConfigurationVersion(configurationVersion string) *GetAllSSLFrontUsesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all s s l front uses default response
func (o *GetAllSSLFrontUsesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all s s l front uses default response
func (o *GetAllSSLFrontUsesDefault) WithPayload(payload *models.Error) *GetAllSSLFrontUsesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all s s l front uses default response
func (o *GetAllSSLFrontUsesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllSSLFrontUsesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
