// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_front_use

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// GetSSLFrontUseHandlerFunc turns a function with the right signature into a get s s l front use handler
type GetSSLFrontUseHandlerFunc func(GetSSLFrontUseParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetSSLFrontUseHandlerFunc) Handle(params GetSSLFrontUseParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetSSLFrontUseHandler interface for that can handle valid get s s l front use params
type GetSSLFrontUseHandler interface {
	Handle(GetSSLFrontUseParams, interface{}) middleware.Responder
}

// NewGetSSLFrontUse creates a new http.Handler for the get s s l front use operation
func NewGetSSLFrontUse(ctx *middleware.Context, handler GetSSLFrontUseHandler) *GetSSLFrontUse {
	return &GetSSLFrontUse{Context: ctx, Handler: handler}
}

/*
	GetSSLFrontUse swagger:route GET /services/haproxy/configuration/frontends/{parent_name}/ssl_front_uses/{index} SSLFrontUse getSSLFrontUse

# Return one SSLFrontUse

Returns one SSLFrontUse configuration by its index in the specified frontend.
*/
type GetSSLFrontUse struct {
	Context *middleware.Context
	Handler GetSSLFrontUseHandler
}

func (o *GetSSLFrontUse) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetSSLFrontUseParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
