// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_front_use

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetSSLFrontUseOKCode is the HTTP code returned for type GetSSLFrontUseOK
const GetSSLFrontUseOKCode int = 200

/*
GetSSLFrontUseOK Successful operation

swagger:response getSSLFrontUseOK
*/
type GetSSLFrontUseOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.SSLFrontUse `json:"body,omitempty"`
}

// NewGetSSLFrontUseOK creates GetSSLFrontUseOK with default headers values
func NewGetSSLFrontUseOK() *GetSSLFrontUseOK {

	return &GetSSLFrontUseOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get s s l front use o k response
func (o *GetSSLFrontUseOK) WithConfigurationVersion(configurationVersion string) *GetSSLFrontUseOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get s s l front use o k response
func (o *GetSSLFrontUseOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get s s l front use o k response
func (o *GetSSLFrontUseOK) WithPayload(payload *models.SSLFrontUse) *GetSSLFrontUseOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get s s l front use o k response
func (o *GetSSLFrontUseOK) SetPayload(payload *models.SSLFrontUse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSSLFrontUseOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetSSLFrontUseNotFoundCode is the HTTP code returned for type GetSSLFrontUseNotFound
const GetSSLFrontUseNotFoundCode int = 404

/*
GetSSLFrontUseNotFound The specified resource already exists

swagger:response getSSLFrontUseNotFound
*/
type GetSSLFrontUseNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetSSLFrontUseNotFound creates GetSSLFrontUseNotFound with default headers values
func NewGetSSLFrontUseNotFound() *GetSSLFrontUseNotFound {

	return &GetSSLFrontUseNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get s s l front use not found response
func (o *GetSSLFrontUseNotFound) WithConfigurationVersion(configurationVersion string) *GetSSLFrontUseNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get s s l front use not found response
func (o *GetSSLFrontUseNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get s s l front use not found response
func (o *GetSSLFrontUseNotFound) WithPayload(payload *models.Error) *GetSSLFrontUseNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get s s l front use not found response
func (o *GetSSLFrontUseNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSSLFrontUseNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetSSLFrontUseDefault General Error

swagger:response getSSLFrontUseDefault
*/
type GetSSLFrontUseDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetSSLFrontUseDefault creates GetSSLFrontUseDefault with default headers values
func NewGetSSLFrontUseDefault(code int) *GetSSLFrontUseDefault {
	if code <= 0 {
		code = 500
	}

	return &GetSSLFrontUseDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get s s l front use default response
func (o *GetSSLFrontUseDefault) WithStatusCode(code int) *GetSSLFrontUseDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get s s l front use default response
func (o *GetSSLFrontUseDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get s s l front use default response
func (o *GetSSLFrontUseDefault) WithConfigurationVersion(configurationVersion string) *GetSSLFrontUseDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get s s l front use default response
func (o *GetSSLFrontUseDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get s s l front use default response
func (o *GetSSLFrontUseDefault) WithPayload(payload *models.Error) *GetSSLFrontUseDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get s s l front use default response
func (o *GetSSLFrontUseDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSSLFrontUseDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
