// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// AddCaEntryCreatedCode is the HTTP code returned for type AddCaEntryCreated
const AddCaEntryCreatedCode int = 201

/*
AddCaEntryCreated Successful operation

swagger:response addCaEntryCreated
*/
type AddCaEntryCreated struct {

	/*
	  In: Body
	*/
	Payload *models.SslCertificate `json:"body,omitempty"`
}

// NewAddCaEntryCreated creates AddCaEntryCreated with default headers values
func NewAddCaEntryCreated() *AddCaEntryCreated {

	return &AddCaEntryCreated{}
}

// WithPayload adds the payload to the add ca entry created response
func (o *AddCaEntryCreated) WithPayload(payload *models.SslCertificate) *AddCaEntryCreated {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add ca entry created response
func (o *AddCaEntryCreated) SetPayload(payload *models.SslCertificate) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddCaEntryCreated) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(201)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// AddCaEntryNotFoundCode is the HTTP code returned for type AddCaEntryNotFound
const AddCaEntryNotFoundCode int = 404

/*
AddCaEntryNotFound The specified resource was not found

swagger:response addCaEntryNotFound
*/
type AddCaEntryNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewAddCaEntryNotFound creates AddCaEntryNotFound with default headers values
func NewAddCaEntryNotFound() *AddCaEntryNotFound {

	return &AddCaEntryNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the add ca entry not found response
func (o *AddCaEntryNotFound) WithConfigurationVersion(configurationVersion string) *AddCaEntryNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the add ca entry not found response
func (o *AddCaEntryNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the add ca entry not found response
func (o *AddCaEntryNotFound) WithPayload(payload *models.Error) *AddCaEntryNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add ca entry not found response
func (o *AddCaEntryNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddCaEntryNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
AddCaEntryDefault General Error

swagger:response addCaEntryDefault
*/
type AddCaEntryDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewAddCaEntryDefault creates AddCaEntryDefault with default headers values
func NewAddCaEntryDefault(code int) *AddCaEntryDefault {
	if code <= 0 {
		code = 500
	}

	return &AddCaEntryDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the add ca entry default response
func (o *AddCaEntryDefault) WithStatusCode(code int) *AddCaEntryDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the add ca entry default response
func (o *AddCaEntryDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the add ca entry default response
func (o *AddCaEntryDefault) WithConfigurationVersion(configurationVersion string) *AddCaEntryDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the add ca entry default response
func (o *AddCaEntryDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the add ca entry default response
func (o *AddCaEntryDefault) WithPayload(payload *models.Error) *AddCaEntryDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add ca entry default response
func (o *AddCaEntryDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddCaEntryDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
