// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// AddCrtListEntryCreatedCode is the HTTP code returned for type AddCrtListEntryCreated
const AddCrtListEntryCreatedCode int = 201

/*
AddCrtListEntryCreated Successful operation

swagger:response addCrtListEntryCreated
*/
type AddCrtListEntryCreated struct {
}

// NewAddCrtListEntryCreated creates AddCrtListEntryCreated with default headers values
func NewAddCrtListEntryCreated() *AddCrtListEntryCreated {

	return &AddCrtListEntryCreated{}
}

// WriteResponse to the client
func (o *AddCrtListEntryCreated) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(201)
}

// AddCrtListEntryBadRequestCode is the HTTP code returned for type AddCrtListEntryBadRequest
const AddCrtListEntryBadRequestCode int = 400

/*
AddCrtListEntryBadRequest Bad request

swagger:response addCrtListEntryBadRequest
*/
type AddCrtListEntryBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewAddCrtListEntryBadRequest creates AddCrtListEntryBadRequest with default headers values
func NewAddCrtListEntryBadRequest() *AddCrtListEntryBadRequest {

	return &AddCrtListEntryBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the add crt list entry bad request response
func (o *AddCrtListEntryBadRequest) WithConfigurationVersion(configurationVersion string) *AddCrtListEntryBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the add crt list entry bad request response
func (o *AddCrtListEntryBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the add crt list entry bad request response
func (o *AddCrtListEntryBadRequest) WithPayload(payload *models.Error) *AddCrtListEntryBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add crt list entry bad request response
func (o *AddCrtListEntryBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddCrtListEntryBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// AddCrtListEntryConflictCode is the HTTP code returned for type AddCrtListEntryConflict
const AddCrtListEntryConflictCode int = 409

/*
AddCrtListEntryConflict The specified resource already exists

swagger:response addCrtListEntryConflict
*/
type AddCrtListEntryConflict struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewAddCrtListEntryConflict creates AddCrtListEntryConflict with default headers values
func NewAddCrtListEntryConflict() *AddCrtListEntryConflict {

	return &AddCrtListEntryConflict{}
}

// WithConfigurationVersion adds the configurationVersion to the add crt list entry conflict response
func (o *AddCrtListEntryConflict) WithConfigurationVersion(configurationVersion string) *AddCrtListEntryConflict {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the add crt list entry conflict response
func (o *AddCrtListEntryConflict) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the add crt list entry conflict response
func (o *AddCrtListEntryConflict) WithPayload(payload *models.Error) *AddCrtListEntryConflict {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add crt list entry conflict response
func (o *AddCrtListEntryConflict) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddCrtListEntryConflict) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(409)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
AddCrtListEntryDefault General Error

swagger:response addCrtListEntryDefault
*/
type AddCrtListEntryDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewAddCrtListEntryDefault creates AddCrtListEntryDefault with default headers values
func NewAddCrtListEntryDefault(code int) *AddCrtListEntryDefault {
	if code <= 0 {
		code = 500
	}

	return &AddCrtListEntryDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the add crt list entry default response
func (o *AddCrtListEntryDefault) WithStatusCode(code int) *AddCrtListEntryDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the add crt list entry default response
func (o *AddCrtListEntryDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the add crt list entry default response
func (o *AddCrtListEntryDefault) WithConfigurationVersion(configurationVersion string) *AddCrtListEntryDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the add crt list entry default response
func (o *AddCrtListEntryDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the add crt list entry default response
func (o *AddCrtListEntryDefault) WithPayload(payload *models.Error) *AddCrtListEntryDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add crt list entry default response
func (o *AddCrtListEntryDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddCrtListEntryDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
