// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// CreateCertCreatedCode is the HTTP code returned for type CreateCertCreated
const CreateCertCreatedCode int = 201

/*
CreateCertCreated Certificate created

swagger:response createCertCreated
*/
type CreateCertCreated struct {
}

// NewCreateCertCreated creates CreateCertCreated with default headers values
func NewCreateCertCreated() *CreateCertCreated {

	return &CreateCertCreated{}
}

// WriteResponse to the client
func (o *CreateCertCreated) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(201)
}

// CreateCertBadRequestCode is the HTTP code returned for type CreateCertBadRequest
const CreateCertBadRequestCode int = 400

/*
CreateCertBadRequest Bad request

swagger:response createCertBadRequest
*/
type CreateCertBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewCreateCertBadRequest creates CreateCertBadRequest with default headers values
func NewCreateCertBadRequest() *CreateCertBadRequest {

	return &CreateCertBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the create cert bad request response
func (o *CreateCertBadRequest) WithConfigurationVersion(configurationVersion string) *CreateCertBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the create cert bad request response
func (o *CreateCertBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the create cert bad request response
func (o *CreateCertBadRequest) WithPayload(payload *models.Error) *CreateCertBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create cert bad request response
func (o *CreateCertBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateCertBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// CreateCertConflictCode is the HTTP code returned for type CreateCertConflict
const CreateCertConflictCode int = 409

/*
CreateCertConflict The specified resource already exists

swagger:response createCertConflict
*/
type CreateCertConflict struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewCreateCertConflict creates CreateCertConflict with default headers values
func NewCreateCertConflict() *CreateCertConflict {

	return &CreateCertConflict{}
}

// WithConfigurationVersion adds the configurationVersion to the create cert conflict response
func (o *CreateCertConflict) WithConfigurationVersion(configurationVersion string) *CreateCertConflict {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the create cert conflict response
func (o *CreateCertConflict) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the create cert conflict response
func (o *CreateCertConflict) WithPayload(payload *models.Error) *CreateCertConflict {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create cert conflict response
func (o *CreateCertConflict) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateCertConflict) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(409)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
CreateCertDefault General Error

swagger:response createCertDefault
*/
type CreateCertDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewCreateCertDefault creates CreateCertDefault with default headers values
func NewCreateCertDefault(code int) *CreateCertDefault {
	if code <= 0 {
		code = 500
	}

	return &CreateCertDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the create cert default response
func (o *CreateCertDefault) WithStatusCode(code int) *CreateCertDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the create cert default response
func (o *CreateCertDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the create cert default response
func (o *CreateCertDefault) WithConfigurationVersion(configurationVersion string) *CreateCertDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the create cert default response
func (o *CreateCertDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the create cert default response
func (o *CreateCertDefault) WithPayload(payload *models.Error) *CreateCertDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create cert default response
func (o *CreateCertDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateCertDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
