// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// CreateCrlCreatedCode is the HTTP code returned for type CreateCrlCreated
const CreateCrlCreatedCode int = 201

/*
CreateCrlCreated CRL file created

swagger:response createCrlCreated
*/
type CreateCrlCreated struct {
}

// NewCreateCrlCreated creates CreateCrlCreated with default headers values
func NewCreateCrlCreated() *CreateCrlCreated {

	return &CreateCrlCreated{}
}

// WriteResponse to the client
func (o *CreateCrlCreated) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(201)
}

// CreateCrlBadRequestCode is the HTTP code returned for type CreateCrlBadRequest
const CreateCrlBadRequestCode int = 400

/*
CreateCrlBadRequest Bad request

swagger:response createCrlBadRequest
*/
type CreateCrlBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewCreateCrlBadRequest creates CreateCrlBadRequest with default headers values
func NewCreateCrlBadRequest() *CreateCrlBadRequest {

	return &CreateCrlBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the create crl bad request response
func (o *CreateCrlBadRequest) WithConfigurationVersion(configurationVersion string) *CreateCrlBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the create crl bad request response
func (o *CreateCrlBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the create crl bad request response
func (o *CreateCrlBadRequest) WithPayload(payload *models.Error) *CreateCrlBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create crl bad request response
func (o *CreateCrlBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateCrlBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// CreateCrlConflictCode is the HTTP code returned for type CreateCrlConflict
const CreateCrlConflictCode int = 409

/*
CreateCrlConflict The specified resource already exists

swagger:response createCrlConflict
*/
type CreateCrlConflict struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewCreateCrlConflict creates CreateCrlConflict with default headers values
func NewCreateCrlConflict() *CreateCrlConflict {

	return &CreateCrlConflict{}
}

// WithConfigurationVersion adds the configurationVersion to the create crl conflict response
func (o *CreateCrlConflict) WithConfigurationVersion(configurationVersion string) *CreateCrlConflict {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the create crl conflict response
func (o *CreateCrlConflict) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the create crl conflict response
func (o *CreateCrlConflict) WithPayload(payload *models.Error) *CreateCrlConflict {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create crl conflict response
func (o *CreateCrlConflict) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateCrlConflict) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(409)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
CreateCrlDefault General Error

swagger:response createCrlDefault
*/
type CreateCrlDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewCreateCrlDefault creates CreateCrlDefault with default headers values
func NewCreateCrlDefault(code int) *CreateCrlDefault {
	if code <= 0 {
		code = 500
	}

	return &CreateCrlDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the create crl default response
func (o *CreateCrlDefault) WithStatusCode(code int) *CreateCrlDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the create crl default response
func (o *CreateCrlDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the create crl default response
func (o *CreateCrlDefault) WithConfigurationVersion(configurationVersion string) *CreateCrlDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the create crl default response
func (o *CreateCrlDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the create crl default response
func (o *CreateCrlDefault) WithPayload(payload *models.Error) *CreateCrlDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the create crl default response
func (o *CreateCrlDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *CreateCrlDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
