// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteCrlNoContentCode is the HTTP code returned for type DeleteCrlNoContent
const DeleteCrlNoContentCode int = 204

/*
DeleteCrlNoContent File deleted

swagger:response deleteCrlNoContent
*/
type DeleteCrlNoContent struct {
}

// NewDeleteCrlNoContent creates DeleteCrlNoContent with default headers values
func NewDeleteCrlNoContent() *DeleteCrlNoContent {

	return &DeleteCrlNoContent{}
}

// WriteResponse to the client
func (o *DeleteCrlNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteCrlBadRequestCode is the HTTP code returned for type DeleteCrlBadRequest
const DeleteCrlBadRequestCode int = 400

/*
DeleteCrlBadRequest Bad request

swagger:response deleteCrlBadRequest
*/
type DeleteCrlBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteCrlBadRequest creates DeleteCrlBadRequest with default headers values
func NewDeleteCrlBadRequest() *DeleteCrlBadRequest {

	return &DeleteCrlBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the delete crl bad request response
func (o *DeleteCrlBadRequest) WithConfigurationVersion(configurationVersion string) *DeleteCrlBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete crl bad request response
func (o *DeleteCrlBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete crl bad request response
func (o *DeleteCrlBadRequest) WithPayload(payload *models.Error) *DeleteCrlBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete crl bad request response
func (o *DeleteCrlBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteCrlBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteCrlDefault General Error

swagger:response deleteCrlDefault
*/
type DeleteCrlDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteCrlDefault creates DeleteCrlDefault with default headers values
func NewDeleteCrlDefault(code int) *DeleteCrlDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteCrlDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete crl default response
func (o *DeleteCrlDefault) WithStatusCode(code int) *DeleteCrlDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete crl default response
func (o *DeleteCrlDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete crl default response
func (o *DeleteCrlDefault) WithConfigurationVersion(configurationVersion string) *DeleteCrlDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete crl default response
func (o *DeleteCrlDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete crl default response
func (o *DeleteCrlDefault) WithPayload(payload *models.Error) *DeleteCrlDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete crl default response
func (o *DeleteCrlDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteCrlDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
