// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// NewDeleteCrtListEntryParams creates a new DeleteCrtListEntryParams object
//
// There are no default values defined in the spec.
func NewDeleteCrtListEntryParams() DeleteCrtListEntryParams {

	return DeleteCrtListEntryParams{}
}

// DeleteCrtListEntryParams contains all the bound params for the delete crt list entry operation
// typically these are obtained from a http.Request
//
// swagger:parameters deleteCrtListEntry
type DeleteCrtListEntryParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*SSL cert entry name
	  Required: true
	  In: query
	*/
	CertFile string
	/*The line number where the entry is located, in case several entries share the same certificate.
	  Minimum: 1
	  In: query
	*/
	LineNumber *int64
	/*SSL crt list name
	  Required: true
	  In: query
	*/
	Name string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewDeleteCrtListEntryParams() beforehand.
func (o *DeleteCrtListEntryParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qCertFile, qhkCertFile, _ := qs.GetOK("cert_file")
	if err := o.bindCertFile(qCertFile, qhkCertFile, route.Formats); err != nil {
		res = append(res, err)
	}

	qLineNumber, qhkLineNumber, _ := qs.GetOK("line_number")
	if err := o.bindLineNumber(qLineNumber, qhkLineNumber, route.Formats); err != nil {
		res = append(res, err)
	}

	qName, qhkName, _ := qs.GetOK("name")
	if err := o.bindName(qName, qhkName, route.Formats); err != nil {
		res = append(res, err)
	}
	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindCertFile binds and validates parameter CertFile from query.
func (o *DeleteCrtListEntryParams) bindCertFile(rawData []string, hasKey bool, formats strfmt.Registry) error {
	if !hasKey {
		return errors.Required("cert_file", "query", rawData)
	}
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// AllowEmptyValue: false

	if err := validate.RequiredString("cert_file", "query", raw); err != nil {
		return err
	}
	o.CertFile = raw

	return nil
}

// bindLineNumber binds and validates parameter LineNumber from query.
func (o *DeleteCrtListEntryParams) bindLineNumber(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false

	if raw == "" { // empty values pass all other validations
		return nil
	}

	value, err := swag.ConvertInt64(raw)
	if err != nil {
		return errors.InvalidType("line_number", "query", "int64", raw)
	}
	o.LineNumber = &value

	if err := o.validateLineNumber(formats); err != nil {
		return err
	}

	return nil
}

// validateLineNumber carries on validations for parameter LineNumber
func (o *DeleteCrtListEntryParams) validateLineNumber(formats strfmt.Registry) error {

	if err := validate.MinimumInt("line_number", "query", *o.LineNumber, 1, false); err != nil {
		return err
	}

	return nil
}

// bindName binds and validates parameter Name from query.
func (o *DeleteCrtListEntryParams) bindName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	if !hasKey {
		return errors.Required("name", "query", rawData)
	}
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// AllowEmptyValue: false

	if err := validate.RequiredString("name", "query", raw); err != nil {
		return err
	}
	o.Name = raw

	return nil
}
