// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteCrtListEntryNoContentCode is the HTTP code returned for type DeleteCrtListEntryNoContent
const DeleteCrtListEntryNoContentCode int = 204

/*
DeleteCrtListEntryNoContent Successful operation

swagger:response deleteCrtListEntryNoContent
*/
type DeleteCrtListEntryNoContent struct {
}

// NewDeleteCrtListEntryNoContent creates DeleteCrtListEntryNoContent with default headers values
func NewDeleteCrtListEntryNoContent() *DeleteCrtListEntryNoContent {

	return &DeleteCrtListEntryNoContent{}
}

// WriteResponse to the client
func (o *DeleteCrtListEntryNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteCrtListEntryBadRequestCode is the HTTP code returned for type DeleteCrtListEntryBadRequest
const DeleteCrtListEntryBadRequestCode int = 400

/*
DeleteCrtListEntryBadRequest Bad request

swagger:response deleteCrtListEntryBadRequest
*/
type DeleteCrtListEntryBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteCrtListEntryBadRequest creates DeleteCrtListEntryBadRequest with default headers values
func NewDeleteCrtListEntryBadRequest() *DeleteCrtListEntryBadRequest {

	return &DeleteCrtListEntryBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the delete crt list entry bad request response
func (o *DeleteCrtListEntryBadRequest) WithConfigurationVersion(configurationVersion string) *DeleteCrtListEntryBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete crt list entry bad request response
func (o *DeleteCrtListEntryBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete crt list entry bad request response
func (o *DeleteCrtListEntryBadRequest) WithPayload(payload *models.Error) *DeleteCrtListEntryBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete crt list entry bad request response
func (o *DeleteCrtListEntryBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteCrtListEntryBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteCrtListEntryNotFoundCode is the HTTP code returned for type DeleteCrtListEntryNotFound
const DeleteCrtListEntryNotFoundCode int = 404

/*
DeleteCrtListEntryNotFound The specified resource was not found

swagger:response deleteCrtListEntryNotFound
*/
type DeleteCrtListEntryNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteCrtListEntryNotFound creates DeleteCrtListEntryNotFound with default headers values
func NewDeleteCrtListEntryNotFound() *DeleteCrtListEntryNotFound {

	return &DeleteCrtListEntryNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete crt list entry not found response
func (o *DeleteCrtListEntryNotFound) WithConfigurationVersion(configurationVersion string) *DeleteCrtListEntryNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete crt list entry not found response
func (o *DeleteCrtListEntryNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete crt list entry not found response
func (o *DeleteCrtListEntryNotFound) WithPayload(payload *models.Error) *DeleteCrtListEntryNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete crt list entry not found response
func (o *DeleteCrtListEntryNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteCrtListEntryNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteCrtListEntryDefault General Error

swagger:response deleteCrtListEntryDefault
*/
type DeleteCrtListEntryDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteCrtListEntryDefault creates DeleteCrtListEntryDefault with default headers values
func NewDeleteCrtListEntryDefault(code int) *DeleteCrtListEntryDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteCrtListEntryDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete crt list entry default response
func (o *DeleteCrtListEntryDefault) WithStatusCode(code int) *DeleteCrtListEntryDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete crt list entry default response
func (o *DeleteCrtListEntryDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete crt list entry default response
func (o *DeleteCrtListEntryDefault) WithConfigurationVersion(configurationVersion string) *DeleteCrtListEntryDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete crt list entry default response
func (o *DeleteCrtListEntryDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete crt list entry default response
func (o *DeleteCrtListEntryDefault) WithPayload(payload *models.Error) *DeleteCrtListEntryDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete crt list entry default response
func (o *DeleteCrtListEntryDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteCrtListEntryDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
