// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllCaFilesOKCode is the HTTP code returned for type GetAllCaFilesOK
const GetAllCaFilesOKCode int = 200

/*
GetAllCaFilesOK Successful operation

swagger:response getAllCaFilesOK
*/
type GetAllCaFilesOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCaFiles `json:"body,omitempty"`
}

// NewGetAllCaFilesOK creates GetAllCaFilesOK with default headers values
func NewGetAllCaFilesOK() *GetAllCaFilesOK {

	return &GetAllCaFilesOK{}
}

// WithPayload adds the payload to the get all ca files o k response
func (o *GetAllCaFilesOK) WithPayload(payload models.SslCaFiles) *GetAllCaFilesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all ca files o k response
func (o *GetAllCaFilesOK) SetPayload(payload models.SslCaFiles) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCaFilesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCaFiles{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllCaFilesDefault General Error

swagger:response getAllCaFilesDefault
*/
type GetAllCaFilesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllCaFilesDefault creates GetAllCaFilesDefault with default headers values
func NewGetAllCaFilesDefault(code int) *GetAllCaFilesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllCaFilesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all ca files default response
func (o *GetAllCaFilesDefault) WithStatusCode(code int) *GetAllCaFilesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all ca files default response
func (o *GetAllCaFilesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all ca files default response
func (o *GetAllCaFilesDefault) WithConfigurationVersion(configurationVersion string) *GetAllCaFilesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all ca files default response
func (o *GetAllCaFilesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all ca files default response
func (o *GetAllCaFilesDefault) WithPayload(payload *models.Error) *GetAllCaFilesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all ca files default response
func (o *GetAllCaFilesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCaFilesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
