// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllCertsOKCode is the HTTP code returned for type GetAllCertsOK
const GetAllCertsOKCode int = 200

/*
GetAllCertsOK Successful operation

swagger:response getAllCertsOK
*/
type GetAllCertsOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCertificates `json:"body,omitempty"`
}

// NewGetAllCertsOK creates GetAllCertsOK with default headers values
func NewGetAllCertsOK() *GetAllCertsOK {

	return &GetAllCertsOK{}
}

// WithPayload adds the payload to the get all certs o k response
func (o *GetAllCertsOK) WithPayload(payload models.SslCertificates) *GetAllCertsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all certs o k response
func (o *GetAllCertsOK) SetPayload(payload models.SslCertificates) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCertsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCertificates{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllCertsDefault General Error

swagger:response getAllCertsDefault
*/
type GetAllCertsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllCertsDefault creates GetAllCertsDefault with default headers values
func NewGetAllCertsDefault(code int) *GetAllCertsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllCertsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all certs default response
func (o *GetAllCertsDefault) WithStatusCode(code int) *GetAllCertsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all certs default response
func (o *GetAllCertsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all certs default response
func (o *GetAllCertsDefault) WithConfigurationVersion(configurationVersion string) *GetAllCertsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all certs default response
func (o *GetAllCertsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all certs default response
func (o *GetAllCertsDefault) WithPayload(payload *models.Error) *GetAllCertsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all certs default response
func (o *GetAllCertsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCertsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
