// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllCrlOKCode is the HTTP code returned for type GetAllCrlOK
const GetAllCrlOKCode int = 200

/*
GetAllCrlOK Successful operation

swagger:response getAllCrlOK
*/
type GetAllCrlOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCrls `json:"body,omitempty"`
}

// NewGetAllCrlOK creates GetAllCrlOK with default headers values
func NewGetAllCrlOK() *GetAllCrlOK {

	return &GetAllCrlOK{}
}

// WithPayload adds the payload to the get all crl o k response
func (o *GetAllCrlOK) WithPayload(payload models.SslCrls) *GetAllCrlOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all crl o k response
func (o *GetAllCrlOK) SetPayload(payload models.SslCrls) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCrlOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCrls{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllCrlDefault General Error

swagger:response getAllCrlDefault
*/
type GetAllCrlDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllCrlDefault creates GetAllCrlDefault with default headers values
func NewGetAllCrlDefault(code int) *GetAllCrlDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllCrlDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all crl default response
func (o *GetAllCrlDefault) WithStatusCode(code int) *GetAllCrlDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all crl default response
func (o *GetAllCrlDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all crl default response
func (o *GetAllCrlDefault) WithConfigurationVersion(configurationVersion string) *GetAllCrlDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all crl default response
func (o *GetAllCrlDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all crl default response
func (o *GetAllCrlDefault) WithPayload(payload *models.Error) *GetAllCrlDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all crl default response
func (o *GetAllCrlDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCrlDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
