// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllCrtListEntriesOKCode is the HTTP code returned for type GetAllCrtListEntriesOK
const GetAllCrtListEntriesOKCode int = 200

/*
GetAllCrtListEntriesOK Successful operation

swagger:response getAllCrtListEntriesOK
*/
type GetAllCrtListEntriesOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCrtListEntries `json:"body,omitempty"`
}

// NewGetAllCrtListEntriesOK creates GetAllCrtListEntriesOK with default headers values
func NewGetAllCrtListEntriesOK() *GetAllCrtListEntriesOK {

	return &GetAllCrtListEntriesOK{}
}

// WithPayload adds the payload to the get all crt list entries o k response
func (o *GetAllCrtListEntriesOK) WithPayload(payload models.SslCrtListEntries) *GetAllCrtListEntriesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all crt list entries o k response
func (o *GetAllCrtListEntriesOK) SetPayload(payload models.SslCrtListEntries) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCrtListEntriesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCrtListEntries{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllCrtListEntriesDefault General Error

swagger:response getAllCrtListEntriesDefault
*/
type GetAllCrtListEntriesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllCrtListEntriesDefault creates GetAllCrtListEntriesDefault with default headers values
func NewGetAllCrtListEntriesDefault(code int) *GetAllCrtListEntriesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllCrtListEntriesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all crt list entries default response
func (o *GetAllCrtListEntriesDefault) WithStatusCode(code int) *GetAllCrtListEntriesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all crt list entries default response
func (o *GetAllCrtListEntriesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all crt list entries default response
func (o *GetAllCrtListEntriesDefault) WithConfigurationVersion(configurationVersion string) *GetAllCrtListEntriesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all crt list entries default response
func (o *GetAllCrtListEntriesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all crt list entries default response
func (o *GetAllCrtListEntriesDefault) WithPayload(payload *models.Error) *GetAllCrtListEntriesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all crt list entries default response
func (o *GetAllCrtListEntriesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllCrtListEntriesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
