// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetCaEntryOKCode is the HTTP code returned for type GetCaEntryOK
const GetCaEntryOKCode int = 200

/*
GetCaEntryOK Successful operation

swagger:response getCaEntryOK
*/
type GetCaEntryOK struct {

	/*
	  In: Body
	*/
	Payload *models.SslCertificate `json:"body,omitempty"`
}

// NewGetCaEntryOK creates GetCaEntryOK with default headers values
func NewGetCaEntryOK() *GetCaEntryOK {

	return &GetCaEntryOK{}
}

// WithPayload adds the payload to the get ca entry o k response
func (o *GetCaEntryOK) WithPayload(payload *models.SslCertificate) *GetCaEntryOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get ca entry o k response
func (o *GetCaEntryOK) SetPayload(payload *models.SslCertificate) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCaEntryOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetCaEntryNotFoundCode is the HTTP code returned for type GetCaEntryNotFound
const GetCaEntryNotFoundCode int = 404

/*
GetCaEntryNotFound The specified resource was not found

swagger:response getCaEntryNotFound
*/
type GetCaEntryNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCaEntryNotFound creates GetCaEntryNotFound with default headers values
func NewGetCaEntryNotFound() *GetCaEntryNotFound {

	return &GetCaEntryNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get ca entry not found response
func (o *GetCaEntryNotFound) WithConfigurationVersion(configurationVersion string) *GetCaEntryNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get ca entry not found response
func (o *GetCaEntryNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get ca entry not found response
func (o *GetCaEntryNotFound) WithPayload(payload *models.Error) *GetCaEntryNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get ca entry not found response
func (o *GetCaEntryNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCaEntryNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetCaEntryDefault General Error

swagger:response getCaEntryDefault
*/
type GetCaEntryDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCaEntryDefault creates GetCaEntryDefault with default headers values
func NewGetCaEntryDefault(code int) *GetCaEntryDefault {
	if code <= 0 {
		code = 500
	}

	return &GetCaEntryDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get ca entry default response
func (o *GetCaEntryDefault) WithStatusCode(code int) *GetCaEntryDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get ca entry default response
func (o *GetCaEntryDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get ca entry default response
func (o *GetCaEntryDefault) WithConfigurationVersion(configurationVersion string) *GetCaEntryDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get ca entry default response
func (o *GetCaEntryDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get ca entry default response
func (o *GetCaEntryDefault) WithPayload(payload *models.Error) *GetCaEntryDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get ca entry default response
func (o *GetCaEntryDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCaEntryDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
