// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetCaFileOKCode is the HTTP code returned for type GetCaFileOK
const GetCaFileOKCode int = 200

/*
GetCaFileOK Successful operation

swagger:response getCaFileOK
*/
type GetCaFileOK struct {

	/*
	  In: Body
	*/
	Payload *models.SslCaFile `json:"body,omitempty"`
}

// NewGetCaFileOK creates GetCaFileOK with default headers values
func NewGetCaFileOK() *GetCaFileOK {

	return &GetCaFileOK{}
}

// WithPayload adds the payload to the get ca file o k response
func (o *GetCaFileOK) WithPayload(payload *models.SslCaFile) *GetCaFileOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get ca file o k response
func (o *GetCaFileOK) SetPayload(payload *models.SslCaFile) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCaFileOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetCaFileNotFoundCode is the HTTP code returned for type GetCaFileNotFound
const GetCaFileNotFoundCode int = 404

/*
GetCaFileNotFound The specified resource was not found

swagger:response getCaFileNotFound
*/
type GetCaFileNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCaFileNotFound creates GetCaFileNotFound with default headers values
func NewGetCaFileNotFound() *GetCaFileNotFound {

	return &GetCaFileNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get ca file not found response
func (o *GetCaFileNotFound) WithConfigurationVersion(configurationVersion string) *GetCaFileNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get ca file not found response
func (o *GetCaFileNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get ca file not found response
func (o *GetCaFileNotFound) WithPayload(payload *models.Error) *GetCaFileNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get ca file not found response
func (o *GetCaFileNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCaFileNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetCaFileDefault General Error

swagger:response getCaFileDefault
*/
type GetCaFileDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCaFileDefault creates GetCaFileDefault with default headers values
func NewGetCaFileDefault(code int) *GetCaFileDefault {
	if code <= 0 {
		code = 500
	}

	return &GetCaFileDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get ca file default response
func (o *GetCaFileDefault) WithStatusCode(code int) *GetCaFileDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get ca file default response
func (o *GetCaFileDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get ca file default response
func (o *GetCaFileDefault) WithConfigurationVersion(configurationVersion string) *GetCaFileDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get ca file default response
func (o *GetCaFileDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get ca file default response
func (o *GetCaFileDefault) WithPayload(payload *models.Error) *GetCaFileDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get ca file default response
func (o *GetCaFileDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCaFileDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
