// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetCertOKCode is the HTTP code returned for type GetCertOK
const GetCertOKCode int = 200

/*
GetCertOK Successful operation

swagger:response getCertOK
*/
type GetCertOK struct {

	/*
	  In: Body
	*/
	Payload *models.SslCertificate `json:"body,omitempty"`
}

// NewGetCertOK creates GetCertOK with default headers values
func NewGetCertOK() *GetCertOK {

	return &GetCertOK{}
}

// WithPayload adds the payload to the get cert o k response
func (o *GetCertOK) WithPayload(payload *models.SslCertificate) *GetCertOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get cert o k response
func (o *GetCertOK) SetPayload(payload *models.SslCertificate) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCertOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetCertDefault General Error

swagger:response getCertDefault
*/
type GetCertDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCertDefault creates GetCertDefault with default headers values
func NewGetCertDefault(code int) *GetCertDefault {
	if code <= 0 {
		code = 500
	}

	return &GetCertDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get cert default response
func (o *GetCertDefault) WithStatusCode(code int) *GetCertDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get cert default response
func (o *GetCertDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get cert default response
func (o *GetCertDefault) WithConfigurationVersion(configurationVersion string) *GetCertDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get cert default response
func (o *GetCertDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get cert default response
func (o *GetCertDefault) WithPayload(payload *models.Error) *GetCertDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get cert default response
func (o *GetCertDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCertDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
