// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetCrlOKCode is the HTTP code returned for type GetCrlOK
const GetCrlOKCode int = 200

/*
GetCrlOK Successful operation

swagger:response getCrlOK
*/
type GetCrlOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCrlEntries `json:"body,omitempty"`
}

// NewGetCrlOK creates GetCrlOK with default headers values
func NewGetCrlOK() *GetCrlOK {

	return &GetCrlOK{}
}

// WithPayload adds the payload to the get crl o k response
func (o *GetCrlOK) WithPayload(payload models.SslCrlEntries) *GetCrlOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get crl o k response
func (o *GetCrlOK) SetPayload(payload models.SslCrlEntries) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCrlOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCrlEntries{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// GetCrlNotFoundCode is the HTTP code returned for type GetCrlNotFound
const GetCrlNotFoundCode int = 404

/*
GetCrlNotFound The specified resource was not found

swagger:response getCrlNotFound
*/
type GetCrlNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCrlNotFound creates GetCrlNotFound with default headers values
func NewGetCrlNotFound() *GetCrlNotFound {

	return &GetCrlNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get crl not found response
func (o *GetCrlNotFound) WithConfigurationVersion(configurationVersion string) *GetCrlNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get crl not found response
func (o *GetCrlNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get crl not found response
func (o *GetCrlNotFound) WithPayload(payload *models.Error) *GetCrlNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get crl not found response
func (o *GetCrlNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCrlNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetCrlDefault General Error

swagger:response getCrlDefault
*/
type GetCrlDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetCrlDefault creates GetCrlDefault with default headers values
func NewGetCrlDefault(code int) *GetCrlDefault {
	if code <= 0 {
		code = 500
	}

	return &GetCrlDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get crl default response
func (o *GetCrlDefault) WithStatusCode(code int) *GetCrlDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get crl default response
func (o *GetCrlDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get crl default response
func (o *GetCrlDefault) WithConfigurationVersion(configurationVersion string) *GetCrlDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get crl default response
func (o *GetCrlDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get crl default response
func (o *GetCrlDefault) WithPayload(payload *models.Error) *GetCrlDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get crl default response
func (o *GetCrlDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetCrlDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
