// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ReplaceCertHandlerFunc turns a function with the right signature into a replace cert handler
type ReplaceCertHandlerFunc func(ReplaceCertParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn ReplaceCertHandlerFunc) Handle(params ReplaceCertParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// ReplaceCertHandler interface for that can handle valid replace cert params
type ReplaceCertHandler interface {
	Handle(ReplaceCertParams, interface{}) middleware.Responder
}

// NewReplaceCert creates a new http.Handler for the replace cert operation
func NewReplaceCert(ctx *middleware.Context, handler ReplaceCertHandler) *ReplaceCert {
	return &ReplaceCert{Context: ctx, Handler: handler}
}

/*
	ReplaceCert swagger:route PUT /services/haproxy/runtime/ssl_certs/{name} SSLRuntime replaceCert

# Replace the contents of a certificate

Sets a certificate payload using the runtime socket.
*/
type ReplaceCert struct {
	Context *middleware.Context
	Handler ReplaceCertHandler
}

func (o *ReplaceCert) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewReplaceCertParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
