// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// ReplaceCrlOKCode is the HTTP code returned for type ReplaceCrlOK
const ReplaceCrlOKCode int = 200

/*
ReplaceCrlOK File modified

swagger:response replaceCrlOK
*/
type ReplaceCrlOK struct {
}

// NewReplaceCrlOK creates ReplaceCrlOK with default headers values
func NewReplaceCrlOK() *ReplaceCrlOK {

	return &ReplaceCrlOK{}
}

// WriteResponse to the client
func (o *ReplaceCrlOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(200)
}

// ReplaceCrlBadRequestCode is the HTTP code returned for type ReplaceCrlBadRequest
const ReplaceCrlBadRequestCode int = 400

/*
ReplaceCrlBadRequest Bad request

swagger:response replaceCrlBadRequest
*/
type ReplaceCrlBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceCrlBadRequest creates ReplaceCrlBadRequest with default headers values
func NewReplaceCrlBadRequest() *ReplaceCrlBadRequest {

	return &ReplaceCrlBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the replace crl bad request response
func (o *ReplaceCrlBadRequest) WithConfigurationVersion(configurationVersion string) *ReplaceCrlBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace crl bad request response
func (o *ReplaceCrlBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace crl bad request response
func (o *ReplaceCrlBadRequest) WithPayload(payload *models.Error) *ReplaceCrlBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace crl bad request response
func (o *ReplaceCrlBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceCrlBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
ReplaceCrlDefault General Error

swagger:response replaceCrlDefault
*/
type ReplaceCrlDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewReplaceCrlDefault creates ReplaceCrlDefault with default headers values
func NewReplaceCrlDefault(code int) *ReplaceCrlDefault {
	if code <= 0 {
		code = 500
	}

	return &ReplaceCrlDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the replace crl default response
func (o *ReplaceCrlDefault) WithStatusCode(code int) *ReplaceCrlDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the replace crl default response
func (o *ReplaceCrlDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the replace crl default response
func (o *ReplaceCrlDefault) WithConfigurationVersion(configurationVersion string) *ReplaceCrlDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the replace crl default response
func (o *ReplaceCrlDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the replace crl default response
func (o *ReplaceCrlDefault) WithPayload(payload *models.Error) *ReplaceCrlDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the replace crl default response
func (o *ReplaceCrlDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ReplaceCrlDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
