// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"io"
	"mime/multipart"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
)

// SetCaFileMaxParseMemory sets the maximum size in bytes for
// the multipart form parser for this operation.
//
// The default value is 32 MB.
// The multipart parser stores up to this + 10MB.
var SetCaFileMaxParseMemory int64 = 32 << 20

// NewSetCaFileParams creates a new SetCaFileParams object
//
// There are no default values defined in the spec.
func NewSetCaFileParams() SetCaFileParams {

	return SetCaFileParams{}
}

// SetCaFileParams contains all the bound params for the set ca file operation
// typically these are obtained from a http.Request
//
// swagger:parameters setCaFile
type SetCaFileParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*
	  Required: true
	  In: formData
	*/
	FileUpload io.ReadCloser
	/*SSL CA file name
	  Required: true
	  In: path
	*/
	Name string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewSetCaFileParams() beforehand.
func (o *SetCaFileParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	if err := r.ParseMultipartForm(SetCaFileMaxParseMemory); err != nil {
		if err != http.ErrNotMultipart {
			return errors.New(400, "%v", err)
		} else if err := r.ParseForm(); err != nil {
			return errors.New(400, "%v", err)
		}
	}

	fileUpload, fileUploadHeader, err := r.FormFile("file_upload")
	if err != nil {
		res = append(res, errors.New(400, "reading file %q failed: %v", "fileUpload", err))
	} else if err := o.bindFileUpload(fileUpload, fileUploadHeader); err != nil {
		// Required: true
		res = append(res, err)
	} else {
		o.FileUpload = &runtime.File{Data: fileUpload, Header: fileUploadHeader}
	}

	rName, rhkName, _ := route.Params.GetOK("name")
	if err := o.bindName(rName, rhkName, route.Formats); err != nil {
		res = append(res, err)
	}
	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindFileUpload binds file parameter FileUpload.
//
// The only supported validations on files are MinLength and MaxLength
func (o *SetCaFileParams) bindFileUpload(file multipart.File, header *multipart.FileHeader) error {
	return nil
}

// bindName binds and validates parameter Name from path.
func (o *SetCaFileParams) bindName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route
	o.Name = raw

	return nil
}
