// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package s_s_l_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// SetCaFileOKCode is the HTTP code returned for type SetCaFileOK
const SetCaFileOKCode int = 200

/*
SetCaFileOK SSL CA payload added

swagger:response setCaFileOK
*/
type SetCaFileOK struct {
}

// NewSetCaFileOK creates SetCaFileOK with default headers values
func NewSetCaFileOK() *SetCaFileOK {

	return &SetCaFileOK{}
}

// WriteResponse to the client
func (o *SetCaFileOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(200)
}

// SetCaFileBadRequestCode is the HTTP code returned for type SetCaFileBadRequest
const SetCaFileBadRequestCode int = 400

/*
SetCaFileBadRequest Bad request

swagger:response setCaFileBadRequest
*/
type SetCaFileBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewSetCaFileBadRequest creates SetCaFileBadRequest with default headers values
func NewSetCaFileBadRequest() *SetCaFileBadRequest {

	return &SetCaFileBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the set ca file bad request response
func (o *SetCaFileBadRequest) WithConfigurationVersion(configurationVersion string) *SetCaFileBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the set ca file bad request response
func (o *SetCaFileBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the set ca file bad request response
func (o *SetCaFileBadRequest) WithPayload(payload *models.Error) *SetCaFileBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the set ca file bad request response
func (o *SetCaFileBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SetCaFileBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
SetCaFileDefault General Error

swagger:response setCaFileDefault
*/
type SetCaFileDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewSetCaFileDefault creates SetCaFileDefault with default headers values
func NewSetCaFileDefault(code int) *SetCaFileDefault {
	if code <= 0 {
		code = 500
	}

	return &SetCaFileDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the set ca file default response
func (o *SetCaFileDefault) WithStatusCode(code int) *SetCaFileDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the set ca file default response
func (o *SetCaFileDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the set ca file default response
func (o *SetCaFileDefault) WithConfigurationVersion(configurationVersion string) *SetCaFileDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the set ca file default response
func (o *SetCaFileDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the set ca file default response
func (o *SetCaFileDefault) WithPayload(payload *models.Error) *SetCaFileDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the set ca file default response
func (o *SetCaFileDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SetCaFileDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
