// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteStorageSSLCrtListFileAcceptedCode is the HTTP code returned for type DeleteStorageSSLCrtListFileAccepted
const DeleteStorageSSLCrtListFileAcceptedCode int = 202

/*
DeleteStorageSSLCrtListFileAccepted Certificate list deleted and reload requested

swagger:response deleteStorageSSLCrtListFileAccepted
*/
type DeleteStorageSSLCrtListFileAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteStorageSSLCrtListFileAccepted creates DeleteStorageSSLCrtListFileAccepted with default headers values
func NewDeleteStorageSSLCrtListFileAccepted() *DeleteStorageSSLCrtListFileAccepted {

	return &DeleteStorageSSLCrtListFileAccepted{}
}

// WithReloadID adds the reloadId to the delete storage s s l crt list file accepted response
func (o *DeleteStorageSSLCrtListFileAccepted) WithReloadID(reloadID string) *DeleteStorageSSLCrtListFileAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete storage s s l crt list file accepted response
func (o *DeleteStorageSSLCrtListFileAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteStorageSSLCrtListFileAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteStorageSSLCrtListFileNoContentCode is the HTTP code returned for type DeleteStorageSSLCrtListFileNoContent
const DeleteStorageSSLCrtListFileNoContentCode int = 204

/*
DeleteStorageSSLCrtListFileNoContent Certificate list deleted

swagger:response deleteStorageSSLCrtListFileNoContent
*/
type DeleteStorageSSLCrtListFileNoContent struct {
}

// NewDeleteStorageSSLCrtListFileNoContent creates DeleteStorageSSLCrtListFileNoContent with default headers values
func NewDeleteStorageSSLCrtListFileNoContent() *DeleteStorageSSLCrtListFileNoContent {

	return &DeleteStorageSSLCrtListFileNoContent{}
}

// WriteResponse to the client
func (o *DeleteStorageSSLCrtListFileNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteStorageSSLCrtListFileNotFoundCode is the HTTP code returned for type DeleteStorageSSLCrtListFileNotFound
const DeleteStorageSSLCrtListFileNotFoundCode int = 404

/*
DeleteStorageSSLCrtListFileNotFound The specified resource was not found

swagger:response deleteStorageSSLCrtListFileNotFound
*/
type DeleteStorageSSLCrtListFileNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteStorageSSLCrtListFileNotFound creates DeleteStorageSSLCrtListFileNotFound with default headers values
func NewDeleteStorageSSLCrtListFileNotFound() *DeleteStorageSSLCrtListFileNotFound {

	return &DeleteStorageSSLCrtListFileNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete storage s s l crt list file not found response
func (o *DeleteStorageSSLCrtListFileNotFound) WithConfigurationVersion(configurationVersion string) *DeleteStorageSSLCrtListFileNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete storage s s l crt list file not found response
func (o *DeleteStorageSSLCrtListFileNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete storage s s l crt list file not found response
func (o *DeleteStorageSSLCrtListFileNotFound) WithPayload(payload *models.Error) *DeleteStorageSSLCrtListFileNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete storage s s l crt list file not found response
func (o *DeleteStorageSSLCrtListFileNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteStorageSSLCrtListFileNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteStorageSSLCrtListFileDefault General Error

swagger:response deleteStorageSSLCrtListFileDefault
*/
type DeleteStorageSSLCrtListFileDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteStorageSSLCrtListFileDefault creates DeleteStorageSSLCrtListFileDefault with default headers values
func NewDeleteStorageSSLCrtListFileDefault(code int) *DeleteStorageSSLCrtListFileDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteStorageSSLCrtListFileDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete storage s s l crt list file default response
func (o *DeleteStorageSSLCrtListFileDefault) WithStatusCode(code int) *DeleteStorageSSLCrtListFileDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete storage s s l crt list file default response
func (o *DeleteStorageSSLCrtListFileDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete storage s s l crt list file default response
func (o *DeleteStorageSSLCrtListFileDefault) WithConfigurationVersion(configurationVersion string) *DeleteStorageSSLCrtListFileDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete storage s s l crt list file default response
func (o *DeleteStorageSSLCrtListFileDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete storage s s l crt list file default response
func (o *DeleteStorageSSLCrtListFileDefault) WithPayload(payload *models.Error) *DeleteStorageSSLCrtListFileDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete storage s s l crt list file default response
func (o *DeleteStorageSSLCrtListFileDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteStorageSSLCrtListFileDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
