// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllStorageSSLCrtListFilesOKCode is the HTTP code returned for type GetAllStorageSSLCrtListFilesOK
const GetAllStorageSSLCrtListFilesOKCode int = 200

/*
GetAllStorageSSLCrtListFilesOK Successful operation

swagger:response getAllStorageSSLCrtListFilesOK
*/
type GetAllStorageSSLCrtListFilesOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCrtListFiles `json:"body,omitempty"`
}

// NewGetAllStorageSSLCrtListFilesOK creates GetAllStorageSSLCrtListFilesOK with default headers values
func NewGetAllStorageSSLCrtListFilesOK() *GetAllStorageSSLCrtListFilesOK {

	return &GetAllStorageSSLCrtListFilesOK{}
}

// WithPayload adds the payload to the get all storage s s l crt list files o k response
func (o *GetAllStorageSSLCrtListFilesOK) WithPayload(payload models.SslCrtListFiles) *GetAllStorageSSLCrtListFilesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all storage s s l crt list files o k response
func (o *GetAllStorageSSLCrtListFilesOK) SetPayload(payload models.SslCrtListFiles) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllStorageSSLCrtListFilesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCrtListFiles{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// GetAllStorageSSLCrtListFilesNotFoundCode is the HTTP code returned for type GetAllStorageSSLCrtListFilesNotFound
const GetAllStorageSSLCrtListFilesNotFoundCode int = 404

/*
GetAllStorageSSLCrtListFilesNotFound The specified resource was not found

swagger:response getAllStorageSSLCrtListFilesNotFound
*/
type GetAllStorageSSLCrtListFilesNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllStorageSSLCrtListFilesNotFound creates GetAllStorageSSLCrtListFilesNotFound with default headers values
func NewGetAllStorageSSLCrtListFilesNotFound() *GetAllStorageSSLCrtListFilesNotFound {

	return &GetAllStorageSSLCrtListFilesNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get all storage s s l crt list files not found response
func (o *GetAllStorageSSLCrtListFilesNotFound) WithConfigurationVersion(configurationVersion string) *GetAllStorageSSLCrtListFilesNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all storage s s l crt list files not found response
func (o *GetAllStorageSSLCrtListFilesNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all storage s s l crt list files not found response
func (o *GetAllStorageSSLCrtListFilesNotFound) WithPayload(payload *models.Error) *GetAllStorageSSLCrtListFilesNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all storage s s l crt list files not found response
func (o *GetAllStorageSSLCrtListFilesNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllStorageSSLCrtListFilesNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetAllStorageSSLCrtListFilesDefault General Error

swagger:response getAllStorageSSLCrtListFilesDefault
*/
type GetAllStorageSSLCrtListFilesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllStorageSSLCrtListFilesDefault creates GetAllStorageSSLCrtListFilesDefault with default headers values
func NewGetAllStorageSSLCrtListFilesDefault(code int) *GetAllStorageSSLCrtListFilesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllStorageSSLCrtListFilesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all storage s s l crt list files default response
func (o *GetAllStorageSSLCrtListFilesDefault) WithStatusCode(code int) *GetAllStorageSSLCrtListFilesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all storage s s l crt list files default response
func (o *GetAllStorageSSLCrtListFilesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all storage s s l crt list files default response
func (o *GetAllStorageSSLCrtListFilesDefault) WithConfigurationVersion(configurationVersion string) *GetAllStorageSSLCrtListFilesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all storage s s l crt list files default response
func (o *GetAllStorageSSLCrtListFilesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all storage s s l crt list files default response
func (o *GetAllStorageSSLCrtListFilesDefault) WithPayload(payload *models.Error) *GetAllStorageSSLCrtListFilesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all storage s s l crt list files default response
func (o *GetAllStorageSSLCrtListFilesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllStorageSSLCrtListFilesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
