// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"io"
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetOneStorageSSLCrtListFileOKCode is the HTTP code returned for type GetOneStorageSSLCrtListFileOK
const GetOneStorageSSLCrtListFileOKCode int = 200

/*
GetOneStorageSSLCrtListFileOK Successful operation

swagger:response getOneStorageSSLCrtListFileOK
*/
type GetOneStorageSSLCrtListFileOK struct {

	/*
	  In: Body
	*/
	Payload io.ReadCloser `json:"body,omitempty"`
}

// NewGetOneStorageSSLCrtListFileOK creates GetOneStorageSSLCrtListFileOK with default headers values
func NewGetOneStorageSSLCrtListFileOK() *GetOneStorageSSLCrtListFileOK {

	return &GetOneStorageSSLCrtListFileOK{}
}

// WithPayload adds the payload to the get one storage s s l crt list file o k response
func (o *GetOneStorageSSLCrtListFileOK) WithPayload(payload io.ReadCloser) *GetOneStorageSSLCrtListFileOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get one storage s s l crt list file o k response
func (o *GetOneStorageSSLCrtListFileOK) SetPayload(payload io.ReadCloser) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOneStorageSSLCrtListFileOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// GetOneStorageSSLCrtListFileNotFoundCode is the HTTP code returned for type GetOneStorageSSLCrtListFileNotFound
const GetOneStorageSSLCrtListFileNotFoundCode int = 404

/*
GetOneStorageSSLCrtListFileNotFound The specified resource was not found

swagger:response getOneStorageSSLCrtListFileNotFound
*/
type GetOneStorageSSLCrtListFileNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetOneStorageSSLCrtListFileNotFound creates GetOneStorageSSLCrtListFileNotFound with default headers values
func NewGetOneStorageSSLCrtListFileNotFound() *GetOneStorageSSLCrtListFileNotFound {

	return &GetOneStorageSSLCrtListFileNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get one storage s s l crt list file not found response
func (o *GetOneStorageSSLCrtListFileNotFound) WithConfigurationVersion(configurationVersion string) *GetOneStorageSSLCrtListFileNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get one storage s s l crt list file not found response
func (o *GetOneStorageSSLCrtListFileNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get one storage s s l crt list file not found response
func (o *GetOneStorageSSLCrtListFileNotFound) WithPayload(payload *models.Error) *GetOneStorageSSLCrtListFileNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get one storage s s l crt list file not found response
func (o *GetOneStorageSSLCrtListFileNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOneStorageSSLCrtListFileNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetOneStorageSSLCrtListFileDefault General Error

swagger:response getOneStorageSSLCrtListFileDefault
*/
type GetOneStorageSSLCrtListFileDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetOneStorageSSLCrtListFileDefault creates GetOneStorageSSLCrtListFileDefault with default headers values
func NewGetOneStorageSSLCrtListFileDefault(code int) *GetOneStorageSSLCrtListFileDefault {
	if code <= 0 {
		code = 500
	}

	return &GetOneStorageSSLCrtListFileDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get one storage s s l crt list file default response
func (o *GetOneStorageSSLCrtListFileDefault) WithStatusCode(code int) *GetOneStorageSSLCrtListFileDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get one storage s s l crt list file default response
func (o *GetOneStorageSSLCrtListFileDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get one storage s s l crt list file default response
func (o *GetOneStorageSSLCrtListFileDefault) WithConfigurationVersion(configurationVersion string) *GetOneStorageSSLCrtListFileDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get one storage s s l crt list file default response
func (o *GetOneStorageSSLCrtListFileDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get one storage s s l crt list file default response
func (o *GetOneStorageSSLCrtListFileDefault) WithPayload(payload *models.Error) *GetOneStorageSSLCrtListFileDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get one storage s s l crt list file default response
func (o *GetOneStorageSSLCrtListFileDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOneStorageSSLCrtListFileDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
