// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetStorageSSLCrtListEntriesOKCode is the HTTP code returned for type GetStorageSSLCrtListEntriesOK
const GetStorageSSLCrtListEntriesOKCode int = 200

/*
GetStorageSSLCrtListEntriesOK Successful operation

swagger:response getStorageSSLCrtListEntriesOK
*/
type GetStorageSSLCrtListEntriesOK struct {

	/*
	  In: Body
	*/
	Payload models.SslCrtListEntries `json:"body,omitempty"`
}

// NewGetStorageSSLCrtListEntriesOK creates GetStorageSSLCrtListEntriesOK with default headers values
func NewGetStorageSSLCrtListEntriesOK() *GetStorageSSLCrtListEntriesOK {

	return &GetStorageSSLCrtListEntriesOK{}
}

// WithPayload adds the payload to the get storage s s l crt list entries o k response
func (o *GetStorageSSLCrtListEntriesOK) WithPayload(payload models.SslCrtListEntries) *GetStorageSSLCrtListEntriesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get storage s s l crt list entries o k response
func (o *GetStorageSSLCrtListEntriesOK) SetPayload(payload models.SslCrtListEntries) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetStorageSSLCrtListEntriesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.SslCrtListEntries{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// GetStorageSSLCrtListEntriesNotFoundCode is the HTTP code returned for type GetStorageSSLCrtListEntriesNotFound
const GetStorageSSLCrtListEntriesNotFoundCode int = 404

/*
GetStorageSSLCrtListEntriesNotFound The specified resource was not found

swagger:response getStorageSSLCrtListEntriesNotFound
*/
type GetStorageSSLCrtListEntriesNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetStorageSSLCrtListEntriesNotFound creates GetStorageSSLCrtListEntriesNotFound with default headers values
func NewGetStorageSSLCrtListEntriesNotFound() *GetStorageSSLCrtListEntriesNotFound {

	return &GetStorageSSLCrtListEntriesNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get storage s s l crt list entries not found response
func (o *GetStorageSSLCrtListEntriesNotFound) WithConfigurationVersion(configurationVersion string) *GetStorageSSLCrtListEntriesNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get storage s s l crt list entries not found response
func (o *GetStorageSSLCrtListEntriesNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get storage s s l crt list entries not found response
func (o *GetStorageSSLCrtListEntriesNotFound) WithPayload(payload *models.Error) *GetStorageSSLCrtListEntriesNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get storage s s l crt list entries not found response
func (o *GetStorageSSLCrtListEntriesNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetStorageSSLCrtListEntriesNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetStorageSSLCrtListEntriesDefault General Error

swagger:response getStorageSSLCrtListEntriesDefault
*/
type GetStorageSSLCrtListEntriesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetStorageSSLCrtListEntriesDefault creates GetStorageSSLCrtListEntriesDefault with default headers values
func NewGetStorageSSLCrtListEntriesDefault(code int) *GetStorageSSLCrtListEntriesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetStorageSSLCrtListEntriesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get storage s s l crt list entries default response
func (o *GetStorageSSLCrtListEntriesDefault) WithStatusCode(code int) *GetStorageSSLCrtListEntriesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get storage s s l crt list entries default response
func (o *GetStorageSSLCrtListEntriesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get storage s s l crt list entries default response
func (o *GetStorageSSLCrtListEntriesDefault) WithConfigurationVersion(configurationVersion string) *GetStorageSSLCrtListEntriesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get storage s s l crt list entries default response
func (o *GetStorageSSLCrtListEntriesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get storage s s l crt list entries default response
func (o *GetStorageSSLCrtListEntriesDefault) WithPayload(payload *models.Error) *GetStorageSSLCrtListEntriesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get storage s s l crt list entries default response
func (o *GetStorageSSLCrtListEntriesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetStorageSSLCrtListEntriesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
