// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteTCPRequestRuleDefaultsAcceptedCode is the HTTP code returned for type DeleteTCPRequestRuleDefaultsAccepted
const DeleteTCPRequestRuleDefaultsAcceptedCode int = 202

/*
DeleteTCPRequestRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response deleteTcpRequestRuleDefaultsAccepted
*/
type DeleteTCPRequestRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteTCPRequestRuleDefaultsAccepted creates DeleteTCPRequestRuleDefaultsAccepted with default headers values
func NewDeleteTCPRequestRuleDefaultsAccepted() *DeleteTCPRequestRuleDefaultsAccepted {

	return &DeleteTCPRequestRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the delete Tcp request rule defaults accepted response
func (o *DeleteTCPRequestRuleDefaultsAccepted) WithReloadID(reloadID string) *DeleteTCPRequestRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete Tcp request rule defaults accepted response
func (o *DeleteTCPRequestRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteTCPRequestRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteTCPRequestRuleDefaultsNoContentCode is the HTTP code returned for type DeleteTCPRequestRuleDefaultsNoContent
const DeleteTCPRequestRuleDefaultsNoContentCode int = 204

/*
DeleteTCPRequestRuleDefaultsNoContent TCP Request Rule deleted

swagger:response deleteTcpRequestRuleDefaultsNoContent
*/
type DeleteTCPRequestRuleDefaultsNoContent struct {
}

// NewDeleteTCPRequestRuleDefaultsNoContent creates DeleteTCPRequestRuleDefaultsNoContent with default headers values
func NewDeleteTCPRequestRuleDefaultsNoContent() *DeleteTCPRequestRuleDefaultsNoContent {

	return &DeleteTCPRequestRuleDefaultsNoContent{}
}

// WriteResponse to the client
func (o *DeleteTCPRequestRuleDefaultsNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteTCPRequestRuleDefaultsNotFoundCode is the HTTP code returned for type DeleteTCPRequestRuleDefaultsNotFound
const DeleteTCPRequestRuleDefaultsNotFoundCode int = 404

/*
DeleteTCPRequestRuleDefaultsNotFound The specified resource was not found

swagger:response deleteTcpRequestRuleDefaultsNotFound
*/
type DeleteTCPRequestRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteTCPRequestRuleDefaultsNotFound creates DeleteTCPRequestRuleDefaultsNotFound with default headers values
func NewDeleteTCPRequestRuleDefaultsNotFound() *DeleteTCPRequestRuleDefaultsNotFound {

	return &DeleteTCPRequestRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete Tcp request rule defaults not found response
func (o *DeleteTCPRequestRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *DeleteTCPRequestRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Tcp request rule defaults not found response
func (o *DeleteTCPRequestRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Tcp request rule defaults not found response
func (o *DeleteTCPRequestRuleDefaultsNotFound) WithPayload(payload *models.Error) *DeleteTCPRequestRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Tcp request rule defaults not found response
func (o *DeleteTCPRequestRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteTCPRequestRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteTCPRequestRuleDefaultsDefault General Error

swagger:response deleteTcpRequestRuleDefaultsDefault
*/
type DeleteTCPRequestRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteTCPRequestRuleDefaultsDefault creates DeleteTCPRequestRuleDefaultsDefault with default headers values
func NewDeleteTCPRequestRuleDefaultsDefault(code int) *DeleteTCPRequestRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteTCPRequestRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete TCP request rule defaults default response
func (o *DeleteTCPRequestRuleDefaultsDefault) WithStatusCode(code int) *DeleteTCPRequestRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete TCP request rule defaults default response
func (o *DeleteTCPRequestRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete TCP request rule defaults default response
func (o *DeleteTCPRequestRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *DeleteTCPRequestRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete TCP request rule defaults default response
func (o *DeleteTCPRequestRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete TCP request rule defaults default response
func (o *DeleteTCPRequestRuleDefaultsDefault) WithPayload(payload *models.Error) *DeleteTCPRequestRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete TCP request rule defaults default response
func (o *DeleteTCPRequestRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteTCPRequestRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
