// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetTCPRequestRuleDefaultsOKCode is the HTTP code returned for type GetTCPRequestRuleDefaultsOK
const GetTCPRequestRuleDefaultsOKCode int = 200

/*
GetTCPRequestRuleDefaultsOK Successful operation

swagger:response getTcpRequestRuleDefaultsOK
*/
type GetTCPRequestRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.TCPRequestRule `json:"body,omitempty"`
}

// NewGetTCPRequestRuleDefaultsOK creates GetTCPRequestRuleDefaultsOK with default headers values
func NewGetTCPRequestRuleDefaultsOK() *GetTCPRequestRuleDefaultsOK {

	return &GetTCPRequestRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Tcp request rule defaults o k response
func (o *GetTCPRequestRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetTCPRequestRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Tcp request rule defaults o k response
func (o *GetTCPRequestRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Tcp request rule defaults o k response
func (o *GetTCPRequestRuleDefaultsOK) WithPayload(payload *models.TCPRequestRule) *GetTCPRequestRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Tcp request rule defaults o k response
func (o *GetTCPRequestRuleDefaultsOK) SetPayload(payload *models.TCPRequestRule) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPRequestRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetTCPRequestRuleDefaultsNotFoundCode is the HTTP code returned for type GetTCPRequestRuleDefaultsNotFound
const GetTCPRequestRuleDefaultsNotFoundCode int = 404

/*
GetTCPRequestRuleDefaultsNotFound The specified resource was not found

swagger:response getTcpRequestRuleDefaultsNotFound
*/
type GetTCPRequestRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetTCPRequestRuleDefaultsNotFound creates GetTCPRequestRuleDefaultsNotFound with default headers values
func NewGetTCPRequestRuleDefaultsNotFound() *GetTCPRequestRuleDefaultsNotFound {

	return &GetTCPRequestRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Tcp request rule defaults not found response
func (o *GetTCPRequestRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *GetTCPRequestRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Tcp request rule defaults not found response
func (o *GetTCPRequestRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Tcp request rule defaults not found response
func (o *GetTCPRequestRuleDefaultsNotFound) WithPayload(payload *models.Error) *GetTCPRequestRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Tcp request rule defaults not found response
func (o *GetTCPRequestRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPRequestRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetTCPRequestRuleDefaultsDefault General Error

swagger:response getTcpRequestRuleDefaultsDefault
*/
type GetTCPRequestRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetTCPRequestRuleDefaultsDefault creates GetTCPRequestRuleDefaultsDefault with default headers values
func NewGetTCPRequestRuleDefaultsDefault(code int) *GetTCPRequestRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetTCPRequestRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get TCP request rule defaults default response
func (o *GetTCPRequestRuleDefaultsDefault) WithStatusCode(code int) *GetTCPRequestRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get TCP request rule defaults default response
func (o *GetTCPRequestRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get TCP request rule defaults default response
func (o *GetTCPRequestRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetTCPRequestRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get TCP request rule defaults default response
func (o *GetTCPRequestRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get TCP request rule defaults default response
func (o *GetTCPRequestRuleDefaultsDefault) WithPayload(payload *models.Error) *GetTCPRequestRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get TCP request rule defaults default response
func (o *GetTCPRequestRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPRequestRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
