// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// DeleteTCPResponseRuleDefaultsAcceptedCode is the HTTP code returned for type DeleteTCPResponseRuleDefaultsAccepted
const DeleteTCPResponseRuleDefaultsAcceptedCode int = 202

/*
DeleteTCPResponseRuleDefaultsAccepted Configuration change accepted and reload requested

swagger:response deleteTcpResponseRuleDefaultsAccepted
*/
type DeleteTCPResponseRuleDefaultsAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteTCPResponseRuleDefaultsAccepted creates DeleteTCPResponseRuleDefaultsAccepted with default headers values
func NewDeleteTCPResponseRuleDefaultsAccepted() *DeleteTCPResponseRuleDefaultsAccepted {

	return &DeleteTCPResponseRuleDefaultsAccepted{}
}

// WithReloadID adds the reloadId to the delete Tcp response rule defaults accepted response
func (o *DeleteTCPResponseRuleDefaultsAccepted) WithReloadID(reloadID string) *DeleteTCPResponseRuleDefaultsAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete Tcp response rule defaults accepted response
func (o *DeleteTCPResponseRuleDefaultsAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteTCPResponseRuleDefaultsAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteTCPResponseRuleDefaultsNoContentCode is the HTTP code returned for type DeleteTCPResponseRuleDefaultsNoContent
const DeleteTCPResponseRuleDefaultsNoContentCode int = 204

/*
DeleteTCPResponseRuleDefaultsNoContent TCP Response Rule deleted

swagger:response deleteTcpResponseRuleDefaultsNoContent
*/
type DeleteTCPResponseRuleDefaultsNoContent struct {
}

// NewDeleteTCPResponseRuleDefaultsNoContent creates DeleteTCPResponseRuleDefaultsNoContent with default headers values
func NewDeleteTCPResponseRuleDefaultsNoContent() *DeleteTCPResponseRuleDefaultsNoContent {

	return &DeleteTCPResponseRuleDefaultsNoContent{}
}

// WriteResponse to the client
func (o *DeleteTCPResponseRuleDefaultsNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteTCPResponseRuleDefaultsNotFoundCode is the HTTP code returned for type DeleteTCPResponseRuleDefaultsNotFound
const DeleteTCPResponseRuleDefaultsNotFoundCode int = 404

/*
DeleteTCPResponseRuleDefaultsNotFound The specified resource was not found

swagger:response deleteTcpResponseRuleDefaultsNotFound
*/
type DeleteTCPResponseRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteTCPResponseRuleDefaultsNotFound creates DeleteTCPResponseRuleDefaultsNotFound with default headers values
func NewDeleteTCPResponseRuleDefaultsNotFound() *DeleteTCPResponseRuleDefaultsNotFound {

	return &DeleteTCPResponseRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete Tcp response rule defaults not found response
func (o *DeleteTCPResponseRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *DeleteTCPResponseRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Tcp response rule defaults not found response
func (o *DeleteTCPResponseRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Tcp response rule defaults not found response
func (o *DeleteTCPResponseRuleDefaultsNotFound) WithPayload(payload *models.Error) *DeleteTCPResponseRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Tcp response rule defaults not found response
func (o *DeleteTCPResponseRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteTCPResponseRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteTCPResponseRuleDefaultsDefault General Error

swagger:response deleteTcpResponseRuleDefaultsDefault
*/
type DeleteTCPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteTCPResponseRuleDefaultsDefault creates DeleteTCPResponseRuleDefaultsDefault with default headers values
func NewDeleteTCPResponseRuleDefaultsDefault(code int) *DeleteTCPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteTCPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete TCP response rule defaults default response
func (o *DeleteTCPResponseRuleDefaultsDefault) WithStatusCode(code int) *DeleteTCPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete TCP response rule defaults default response
func (o *DeleteTCPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete TCP response rule defaults default response
func (o *DeleteTCPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *DeleteTCPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete TCP response rule defaults default response
func (o *DeleteTCPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete TCP response rule defaults default response
func (o *DeleteTCPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *DeleteTCPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete TCP response rule defaults default response
func (o *DeleteTCPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteTCPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
