// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllTCPResponseRuleDefaultsOKCode is the HTTP code returned for type GetAllTCPResponseRuleDefaultsOK
const GetAllTCPResponseRuleDefaultsOKCode int = 200

/*
GetAllTCPResponseRuleDefaultsOK Successful operation

swagger:response getAllTcpResponseRuleDefaultsOK
*/
type GetAllTCPResponseRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.TCPResponseRules `json:"body,omitempty"`
}

// NewGetAllTCPResponseRuleDefaultsOK creates GetAllTCPResponseRuleDefaultsOK with default headers values
func NewGetAllTCPResponseRuleDefaultsOK() *GetAllTCPResponseRuleDefaultsOK {

	return &GetAllTCPResponseRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all Tcp response rule defaults o k response
func (o *GetAllTCPResponseRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetAllTCPResponseRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all Tcp response rule defaults o k response
func (o *GetAllTCPResponseRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all Tcp response rule defaults o k response
func (o *GetAllTCPResponseRuleDefaultsOK) WithPayload(payload models.TCPResponseRules) *GetAllTCPResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all Tcp response rule defaults o k response
func (o *GetAllTCPResponseRuleDefaultsOK) SetPayload(payload models.TCPResponseRules) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllTCPResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.TCPResponseRules{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllTCPResponseRuleDefaultsDefault General Error

swagger:response getAllTcpResponseRuleDefaultsDefault
*/
type GetAllTCPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllTCPResponseRuleDefaultsDefault creates GetAllTCPResponseRuleDefaultsDefault with default headers values
func NewGetAllTCPResponseRuleDefaultsDefault(code int) *GetAllTCPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllTCPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all TCP response rule defaults default response
func (o *GetAllTCPResponseRuleDefaultsDefault) WithStatusCode(code int) *GetAllTCPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all TCP response rule defaults default response
func (o *GetAllTCPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all TCP response rule defaults default response
func (o *GetAllTCPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetAllTCPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all TCP response rule defaults default response
func (o *GetAllTCPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all TCP response rule defaults default response
func (o *GetAllTCPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *GetAllTCPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all TCP response rule defaults default response
func (o *GetAllTCPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllTCPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
