// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetTCPResponseRuleDefaultsOKCode is the HTTP code returned for type GetTCPResponseRuleDefaultsOK
const GetTCPResponseRuleDefaultsOKCode int = 200

/*
GetTCPResponseRuleDefaultsOK Successful operation

swagger:response getTcpResponseRuleDefaultsOK
*/
type GetTCPResponseRuleDefaultsOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.TCPResponseRule `json:"body,omitempty"`
}

// NewGetTCPResponseRuleDefaultsOK creates GetTCPResponseRuleDefaultsOK with default headers values
func NewGetTCPResponseRuleDefaultsOK() *GetTCPResponseRuleDefaultsOK {

	return &GetTCPResponseRuleDefaultsOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Tcp response rule defaults o k response
func (o *GetTCPResponseRuleDefaultsOK) WithConfigurationVersion(configurationVersion string) *GetTCPResponseRuleDefaultsOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Tcp response rule defaults o k response
func (o *GetTCPResponseRuleDefaultsOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Tcp response rule defaults o k response
func (o *GetTCPResponseRuleDefaultsOK) WithPayload(payload *models.TCPResponseRule) *GetTCPResponseRuleDefaultsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Tcp response rule defaults o k response
func (o *GetTCPResponseRuleDefaultsOK) SetPayload(payload *models.TCPResponseRule) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPResponseRuleDefaultsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetTCPResponseRuleDefaultsNotFoundCode is the HTTP code returned for type GetTCPResponseRuleDefaultsNotFound
const GetTCPResponseRuleDefaultsNotFoundCode int = 404

/*
GetTCPResponseRuleDefaultsNotFound The specified resource was not found

swagger:response getTcpResponseRuleDefaultsNotFound
*/
type GetTCPResponseRuleDefaultsNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetTCPResponseRuleDefaultsNotFound creates GetTCPResponseRuleDefaultsNotFound with default headers values
func NewGetTCPResponseRuleDefaultsNotFound() *GetTCPResponseRuleDefaultsNotFound {

	return &GetTCPResponseRuleDefaultsNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Tcp response rule defaults not found response
func (o *GetTCPResponseRuleDefaultsNotFound) WithConfigurationVersion(configurationVersion string) *GetTCPResponseRuleDefaultsNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Tcp response rule defaults not found response
func (o *GetTCPResponseRuleDefaultsNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Tcp response rule defaults not found response
func (o *GetTCPResponseRuleDefaultsNotFound) WithPayload(payload *models.Error) *GetTCPResponseRuleDefaultsNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Tcp response rule defaults not found response
func (o *GetTCPResponseRuleDefaultsNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPResponseRuleDefaultsNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetTCPResponseRuleDefaultsDefault General Error

swagger:response getTcpResponseRuleDefaultsDefault
*/
type GetTCPResponseRuleDefaultsDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetTCPResponseRuleDefaultsDefault creates GetTCPResponseRuleDefaultsDefault with default headers values
func NewGetTCPResponseRuleDefaultsDefault(code int) *GetTCPResponseRuleDefaultsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetTCPResponseRuleDefaultsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get TCP response rule defaults default response
func (o *GetTCPResponseRuleDefaultsDefault) WithStatusCode(code int) *GetTCPResponseRuleDefaultsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get TCP response rule defaults default response
func (o *GetTCPResponseRuleDefaultsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get TCP response rule defaults default response
func (o *GetTCPResponseRuleDefaultsDefault) WithConfigurationVersion(configurationVersion string) *GetTCPResponseRuleDefaultsDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get TCP response rule defaults default response
func (o *GetTCPResponseRuleDefaultsDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get TCP response rule defaults default response
func (o *GetTCPResponseRuleDefaultsDefault) WithPayload(payload *models.Error) *GetTCPResponseRuleDefaultsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get TCP response rule defaults default response
func (o *GetTCPResponseRuleDefaultsDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPResponseRuleDefaultsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
